/*
 * Copyright (c) 2007, 2015, 2022 -2022 Apple Inc. All rights reserved.
 * Copyright (c) 2013 Google Inc. All rights reserved.
 * Copyright (c) 2014, 2015, 2016, 2019, 2022 Apple Inc. All rights reserved.
 * Copyright (c) 2014, 2017 -2017 Apple Inc. All rights reserved.
 * Copyright (c) 2015 Andy VanWagoner <andy@vanwagoner.family>.
 * Copyright (c) 2015 Jordan Harband. All rights reserved.
 * Copyright (c) 2015, 2016 -2016 Apple Inc. All rights reserved.
 * Copyright (c) 2015, 2016 -2016 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2015, 2016, 2017 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2016 Caitlin Potter <caitp@igalia.com>.
 * Copyright (c) 2016 Yusuke Suzuki <utatane.tea@gmail.com>
 * Copyright (c) 2016, 2017 -2017 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2016, 2017, 2018 Oleksandr Skachkov <gskachkov@gmail.com>.
 * Copyright (c) 2016, 2018 -2018 Apple Inc. All rights reserved.
 * Copyright (c) 2016, 2019 -2019 Apple Inc. All rights reserved.
 * Copyright (c) 2017 Caio Lima <ticaiolima@gmail.com>.
 * Copyright (c) 2018 Yusuke Suzuki <yusukesuzuki@slowstart.org>.
 * Copyright (c) 2019 Alexey Shvayka <shvaikalesh@gmail.com>.
 * Copyright (c) 2021 Igalia S.L.
 * Copyright (c) 2022 Jarred Sumner. All rights reserved.
 * Copyright (c) 2023 Devin Rousso <webkit@devinrousso.com>.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

// DO NOT EDIT THIS FILE. It is automatically generated from JavaScript files for
// builtins by the script: Source/JavaScriptCore/Scripts/generate-js-builtins.py

#include "config.h"
#include "JSCBuiltins.h"

#include "BuiltinExecutables.h"
#include "IdentifierInlines.h"
#include "ImplementationVisibility.h"
#include "Intrinsic.h"
#include "JSCellInlines.h"
#include "UnlinkedFunctionExecutable.h"
#include "VM.h"

namespace JSC {

const char s_JSCCombinedCode[] = { 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 44, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 34, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 116, 97, 107, 101, 115, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 44, 32, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 111, 114, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 116, 97, 107, 101, 115, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 44, 32, 32, 102, 97, 108, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 111, 114, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 69, 120, 112, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 103, 108, 111, 98, 97, 108, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 82, 101, 103, 69, 120, 112, 34, 44, 32, 114, 101, 103, 69, 120, 112, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 83, 116, 114, 105, 110, 103, 34, 44, 32, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 71, 108, 111, 98, 97, 108, 34, 44, 32, 103, 108, 111, 98, 97, 108, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 85, 110, 105, 99, 111, 100, 101, 34, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 102, 97, 108, 115, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 105, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 117, 110, 105, 99, 111, 100, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 43, 32, 49, 32, 62, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 114, 115, 116, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 32, 60, 32, 48, 120, 68, 56, 48, 48, 32, 124, 124, 32, 102, 105, 114, 115, 116, 32, 62, 32, 48, 120, 68, 66, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 99, 111, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 110, 100, 101, 120, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 99, 111, 110, 100, 32, 60, 32, 48, 120, 68, 67, 48, 48, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 32, 62, 32, 48, 120, 68, 70, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 50, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 65, 108, 108, 83, 108, 111, 119, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 115, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 58, 32, 49, 44, 10, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 32, 61, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 65, 108, 108, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 87, 105, 116, 104, 67, 111, 110, 116, 101, 120, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 123, 32, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 44, 32, 105, 110, 100, 101, 120, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 78, 101, 119, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 40, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 46, 64, 99, 97, 108, 108, 40, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 65, 108, 108, 78, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 44, 32, 105, 110, 100, 101, 120, 41, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 45, 45, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 115, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 91, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 117, 115, 58, 32, 34, 102, 117, 108, 102, 105, 108, 108, 101, 100, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 111, 98, 106, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 117, 115, 58, 32, 34, 114, 101, 106, 101, 99, 116, 101, 100, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 97, 115, 111, 110, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 111, 98, 106, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 91, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 93, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 115, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 117, 114, 108, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 97, 34, 44, 32, 34, 110, 97, 109, 101, 34, 44, 32, 117, 114, 108, 41, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 114, 114, 111, 114, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 114, 114, 111, 114, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 110, 101, 119, 32, 64, 65, 103, 103, 114, 101, 103, 97, 116, 101, 69, 114, 114, 111, 114, 40, 101, 114, 114, 111, 114, 115, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 114, 114, 111, 114, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 110, 101, 119, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 110, 101, 119, 32, 64, 65, 103, 103, 114, 101, 103, 97, 116, 101, 69, 114, 114, 111, 114, 40, 101, 114, 114, 111, 114, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 97, 112, 112, 108, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 97, 112, 112, 108, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 116, 104, 105, 114, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 105, 115, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 97, 114, 114, 97, 121, 41, 32, 63, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 41, 32, 58, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 105, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 45, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 102, 97, 108, 115, 101, 32, 125, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 67, 111, 110, 116, 101, 120, 116, 41, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 67, 111, 110, 116, 101, 120, 116, 41, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 118, 97, 108, 117, 101, 44, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 110, 32, 97, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 69, 110, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 123, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 58, 32, 110, 117, 108, 108, 125, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 69, 120, 101, 99, 117, 116, 105, 111, 110, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 33, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 115, 69, 109, 112, 116, 121, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 116, 97, 116, 111, 114, 39, 115, 32, 81, 117, 101, 117, 101, 32, 105, 115, 32, 97, 110, 32, 101, 109, 112, 116, 121, 32, 76, 105, 115, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 114, 101, 115, 117, 108, 116, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 44, 32, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 105, 116, 101, 109, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 105, 116, 101, 109, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 108, 97, 115, 116, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 68, 101, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 68, 101, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 116, 97, 116, 101, 32, 33, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 115, 104, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 105, 110, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 32, 115, 116, 97, 116, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 65, 119, 97, 105, 116, 105, 110, 103, 82, 101, 116, 117, 114, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 115, 69, 109, 112, 116, 121, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 33, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 83, 116, 97, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 65, 119, 97, 105, 116, 105, 110, 103, 82, 101, 116, 117, 114, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 109, 111, 100, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 41, 59, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 83, 116, 97, 114, 116, 32, 124, 124, 32, 64, 105, 115, 83, 117, 115, 112, 101, 110, 100, 89, 105, 101, 108, 100, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 115, 116, 97, 116, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 44, 32, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 59, 10, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 65, 119, 97, 105, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 102, 97, 108, 115, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 65, 98, 115, 116, 114, 97, 99, 116, 77, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 64, 97, 98, 115, 116, 114, 97, 99, 116, 77, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 97, 119, 97, 105, 116, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 63, 32, 97, 114, 114, 97, 121, 91, 107, 93, 32, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 41, 32, 32, 32, 32, 10, 123, 32, 32, 32, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 32, 32, 32, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 32, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 32, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 32, 32, 32, 32, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 63, 32, 115, 116, 114, 105, 110, 103, 91, 107, 93, 32, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 32, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 63, 32, 116, 104, 105, 115, 91, 107, 93, 32, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 105, 103, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 105, 103, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 108, 105, 110, 107, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 111, 108, 100, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 109, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 98, 117, 105, 108, 116, 105, 110, 77, 97, 112, 73, 116, 101, 114, 97, 98, 108, 101, 32, 99, 97, 108, 108, 101, 100, 32, 119, 105, 116, 104, 32, 110, 111, 110, 45, 77, 97, 112, 32, 111, 98, 106, 101, 99, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 101, 116, 32, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 109, 97, 112, 46, 64, 101, 110, 116, 114, 105, 101, 115, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 112, 101, 100, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 109, 97, 112, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 115, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 98, 117, 105, 108, 116, 105, 110, 83, 101, 116, 73, 116, 101, 114, 97, 98, 108, 101, 32, 99, 97, 108, 108, 101, 100, 32, 119, 105, 116, 104, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 101, 116, 32, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 115, 101, 116, 46, 64, 118, 97, 108, 117, 101, 115, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 112, 101, 100, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 115, 101, 116, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 76, 105, 110, 107, 41, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 32, 61, 32, 40, 97, 115, 121, 110, 99, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 125, 41, 40, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 100, 101, 112, 69, 110, 116, 114, 105, 101, 115, 44, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 115, 83, 97, 116, 105, 115, 102, 105, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 69, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 112, 69, 110, 116, 114, 105, 101, 115, 91, 105, 93, 46, 105, 115, 83, 97, 116, 105, 115, 102, 105, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 115, 83, 97, 116, 105, 115, 102, 105, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 115, 83, 97, 116, 105, 115, 102, 105, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 99, 97, 99, 104, 101, 83, 97, 116, 105, 115, 102, 121, 40, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 46, 64, 97, 100, 100, 40, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 44, 32, 105, 45, 49, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 116, 104, 101, 110, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 80, 114, 111, 109, 105, 115, 101, 46, 64, 114, 101, 115, 111, 108, 118, 101, 40, 115, 111, 117, 114, 99, 101, 41, 46, 64, 116, 104, 101, 110, 40, 64, 119, 101, 98, 65, 115, 115, 101, 109, 98, 108, 121, 67, 111, 109, 112, 105, 108, 101, 83, 116, 114, 101, 97, 109, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 105, 114, 115, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 49, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 116, 104, 105, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 87, 105, 116, 104, 87, 101, 108, 108, 75, 110, 111, 119, 110, 83, 121, 109, 98, 111, 108, 40, 116, 104, 105, 115, 44, 32, 34, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 34, 41, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 102, 105, 114, 115, 116, 41, 32, 124, 124, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 87, 105, 116, 104, 87, 101, 108, 108, 75, 110, 111, 119, 110, 83, 121, 109, 98, 111, 108, 40, 102, 105, 114, 115, 116, 44, 32, 34, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 34, 41, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 41, 32, 123, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 111, 110, 99, 97, 116, 77, 101, 109, 99, 112, 121, 40, 116, 104, 105, 115, 44, 32, 102, 105, 114, 115, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 99, 111, 110, 99, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 110, 99, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 115, 116, 114, 105, 110, 103, 67, 111, 110, 99, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 110, 99, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 112, 101, 99, 105, 101, 115, 40, 48, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 73, 115, 65, 114, 114, 97, 121, 32, 61, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 32, 61, 32, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 32, 38, 38, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 46, 64, 64, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 64, 105, 115, 65, 114, 114, 97, 121, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 32, 124, 124, 32, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 73, 115, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 32, 38, 38, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 60, 61, 32, 64, 77, 65, 88, 95, 65, 82, 82, 65, 89, 95, 73, 78, 68, 69, 88, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 112, 112, 101, 110, 100, 77, 101, 109, 99, 112, 121, 40, 114, 101, 115, 117, 108, 116, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 97, 114, 103, 73, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 97, 114, 103, 73, 110, 100, 101, 120, 43, 43, 32, 60, 32, 97, 114, 103, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 116, 97, 114, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 112, 121, 87, 105, 116, 104, 105, 110, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 116, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 111, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 32, 60, 32, 48, 41, 32, 63, 32, 64, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 44, 32, 48, 41, 32, 58, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 32, 63, 32, 64, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 48, 41, 32, 58, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 101, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 60, 32, 48, 41, 32, 63, 32, 64, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 44, 32, 48, 41, 32, 58, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 117, 110, 116, 32, 61, 32, 64, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 102, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 45, 32, 102, 114, 111, 109, 44, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 116, 111, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 60, 32, 116, 111, 32, 38, 38, 32, 116, 111, 32, 60, 32, 102, 114, 111, 109, 32, 43, 32, 99, 111, 117, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 32, 61, 32, 45, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 114, 111, 109, 32, 61, 32, 102, 114, 111, 109, 32, 43, 32, 99, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 111, 32, 61, 32, 116, 111, 32, 43, 32, 99, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 43, 43, 105, 44, 32, 102, 114, 111, 109, 32, 43, 61, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 44, 32, 116, 111, 32, 43, 61, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 116, 111, 93, 32, 61, 32, 97, 114, 114, 97, 121, 91, 102, 114, 111, 109, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 97, 114, 114, 97, 121, 91, 116, 111, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 97, 114, 114, 97, 121, 32, 61, 32, 110, 101, 119, 32, 64, 65, 114, 114, 97, 121, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 97, 114, 114, 97, 121, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 97, 114, 114, 97, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 79, 110, 108, 121, 32, 111, 98, 106, 101, 99, 116, 115, 32, 99, 97, 110, 32, 98, 101, 32, 119, 114, 97, 112, 112, 101, 100, 32, 98, 121, 32, 97, 115, 121, 110, 99, 45, 102, 114, 111, 109, 45, 115, 121, 110, 99, 32, 119, 114, 97, 112, 112, 101, 114, 39, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 65, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 117, 110, 99, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 116, 97, 103, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 116, 114, 105, 110, 103, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 96, 36, 123, 102, 117, 110, 99, 125, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 96, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 83, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 49, 32, 61, 32, 34, 60, 34, 32, 43, 32, 116, 97, 103, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 86, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 115, 99, 97, 112, 101, 100, 86, 32, 61, 32, 86, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 47, 34, 47, 103, 44, 32, 39, 38, 113, 117, 111, 116, 59, 39, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 49, 32, 61, 32, 112, 49, 32, 43, 32, 34, 32, 34, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 41, 32, 43, 32, 39, 61, 34, 39, 32, 43, 32, 101, 115, 99, 97, 112, 101, 100, 86, 32, 43, 32, 39, 34, 39, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 50, 32, 61, 32, 112, 49, 32, 43, 32, 34, 62, 34, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 51, 32, 61, 32, 112, 50, 32, 43, 32, 83, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 52, 32, 61, 32, 112, 51, 32, 43, 32, 34, 60, 47, 34, 32, 43, 32, 116, 97, 103, 32, 43, 32, 34, 62, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 52, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 41, 10, 123, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 40, 41, 32, 123, 125, 10, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 32, 61, 32, 110, 117, 108, 108, 59, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 111, 98, 106, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 49, 32, 47, 32, 111, 98, 106, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 45, 48, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 66, 105, 103, 73, 110, 116, 40, 111, 98, 106, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 32, 43, 32, 34, 110, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 111, 98, 106, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 85, 73, 110, 116, 51, 50, 40, 111, 98, 106, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 32, 62, 62, 62, 32, 48, 32, 61, 61, 61, 32, 111, 98, 106, 32, 38, 38, 32, 40, 111, 98, 106, 32, 62, 32, 48, 32, 124, 124, 32, 49, 32, 47, 32, 111, 98, 106, 32, 62, 32, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 32, 43, 32, 40, 111, 98, 106, 32, 62, 62, 62, 32, 48, 41, 32, 61, 61, 61, 32, 111, 98, 106, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 115, 121, 109, 98, 111, 108, 34, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 98, 105, 103, 105, 110, 116, 34, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 69, 109, 112, 116, 121, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 10, 123, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 107, 101, 121, 32, 105, 110, 32, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 33, 33, 118, 97, 108, 117, 101, 32, 124, 124, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 98, 111, 111, 108, 101, 97, 110, 34, 58, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 110, 117, 109, 98, 101, 114, 34, 58, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 115, 116, 114, 105, 110, 103, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 33, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 125, 10, 32, 32, 32, 32, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 79, 98, 106, 101, 99, 116, 41, 32, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 79, 98, 106, 101, 99, 116, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 112, 101, 100, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 79, 98, 106, 101, 99, 116, 41, 41, 59, 10, 125, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 97, 120, 40, 97, 44, 32, 98, 41, 32, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 32, 62, 32, 98, 32, 63, 32, 97, 32, 58, 32, 98, 59, 10, 125, 10, 10, 47, 47, 10, 10, 108, 101, 116, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 32, 61, 32, 99, 108, 97, 115, 115, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 32, 101, 120, 116, 101, 110, 100, 115, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 10, 123, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 117, 112, 101, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 66, 111, 117, 110, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 101, 40, 102, 117, 110, 99, 116, 105, 111, 110, 83, 116, 114, 105, 110, 103, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 97, 114, 103, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 65, 110, 100, 83, 97, 118, 101, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 87, 105, 116, 104, 83, 99, 111, 112, 101, 69, 120, 116, 101, 110, 115, 105, 111, 110, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 102, 117, 110, 99, 116, 105, 111, 110, 83, 116, 114, 105, 110, 103, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 46, 64, 97, 112, 112, 108, 121, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 65, 110, 100, 87, 114, 97, 112, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 87, 105, 116, 104, 83, 99, 111, 112, 101, 69, 120, 116, 101, 110, 115, 105, 111, 110, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 97, 119, 97, 105, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 80, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 80, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 80, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 111, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 34, 79, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 80, 114, 111, 109, 105, 115, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 118, 97, 108, 117, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 46, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 46, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 114, 101, 97, 115, 111, 110, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 98, 106, 101, 99, 116, 46, 64, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 40, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 99, 97, 108, 108, 70, 114, 97, 109, 101, 70, 111, 114, 73, 100, 40, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 99, 97, 108, 108, 32, 102, 114, 97, 109, 101, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 65, 110, 100, 87, 114, 97, 112, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 101, 118, 97, 108, 117, 97, 116, 101, 87, 105, 116, 104, 83, 99, 111, 112, 101, 69, 120, 116, 101, 110, 115, 105, 111, 110, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 97, 108, 108, 70, 117, 110, 99, 116, 105, 111, 110, 79, 110, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 97, 114, 103, 115, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 97, 119, 97, 105, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 111, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 65, 114, 103, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 97, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 97, 108, 108, 65, 114, 103, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 115, 91, 105, 93, 32, 61, 32, 116, 104, 105, 115, 46, 95, 114, 101, 115, 111, 108, 118, 101, 67, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 40, 99, 97, 108, 108, 65, 114, 103, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 64, 83, 116, 114, 105, 110, 103, 40, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 117, 110, 99, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 102, 117, 110, 99, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 34, 71, 105, 118, 101, 110, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 101, 118, 97, 108, 117, 97, 116, 101, 32, 116, 111, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 102, 117, 110, 99, 46, 64, 97, 112, 112, 108, 121, 40, 111, 98, 106, 101, 99, 116, 44, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 119, 97, 105, 116, 80, 114, 111, 109, 105, 115, 101, 32, 38, 38, 32, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 114, 101, 115, 117, 108, 116, 41, 32, 38, 38, 32, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 116, 104, 101, 110, 40, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 114, 101, 115, 117, 108, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 70, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 98, 121, 32, 105, 100, 46, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 102, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 102, 117, 110, 99, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 116, 97, 105, 108, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 102, 117, 110, 99, 116, 105, 111, 110, 68, 101, 116, 97, 105, 108, 115, 40, 102, 117, 110, 99, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 116, 97, 105, 108, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 100, 101, 116, 97, 105, 108, 115, 46, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 116, 97, 105, 108, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 63, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 58, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 34, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 34, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 34, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 68, 105, 115, 112, 108, 97, 121, 97, 98, 108, 101, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 124, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 34, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 34, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 34, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 103, 101, 116, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 124, 124, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 32, 33, 61, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 116, 104, 105, 115, 46, 95, 101, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 121, 32, 61, 32, 101, 110, 116, 114, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 107, 101, 121, 34, 32, 105, 110, 32, 101, 110, 116, 114, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 105, 101, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 114, 101, 115, 111, 108, 118, 101, 67, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 40, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 115, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 112, 116, 104, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 119, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 40, 100, 101, 112, 116, 104, 43, 43, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 99, 97, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 102, 97, 108, 108, 98, 97, 99, 107, 87, 114, 97, 112, 112, 101, 114, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 74, 83, 79, 78, 83, 116, 114, 105, 110, 103, 40, 106, 115, 111, 110, 83, 116, 114, 105, 110, 103, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 119, 114, 97, 112, 79, 98, 106, 101, 99, 116, 40, 64, 106, 115, 111, 110, 80, 97, 114, 115, 101, 40, 106, 115, 111, 110, 83, 116, 114, 105, 110, 103, 41, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 116, 114, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 114, 97, 112, 84, 97, 98, 108, 101, 40, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 116, 97, 98, 108, 101, 44, 32, 99, 111, 108, 117, 109, 110, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 110, 65, 99, 99, 101, 115, 115, 73, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 102, 97, 108, 108, 98, 97, 99, 107, 87, 114, 97, 112, 112, 101, 114, 40, 116, 97, 98, 108, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 111, 108, 117, 109, 110, 115, 32, 61, 61, 61, 32, 34, 115, 116, 114, 105, 110, 103, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 108, 117, 109, 110, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 99, 111, 108, 117, 109, 110, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 99, 111, 108, 117, 109, 110, 115, 41, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 111, 108, 117, 109, 110, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 44, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 111, 108, 117, 109, 110, 115, 91, 105, 93, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 116, 97, 98, 108, 101, 44, 32, 34, 99, 111, 110, 115, 111, 108, 101, 34, 44, 32, 102, 97, 108, 115, 101, 44, 32, 116, 114, 117, 101, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 101, 116, 69, 118, 101, 110, 116, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 108, 101, 97, 114, 69, 118, 101, 110, 116, 86, 97, 108, 117, 101, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 101, 116, 69, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 108, 101, 97, 114, 69, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 105, 110, 100, 79, 98, 106, 101, 99, 116, 66, 121, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 61, 61, 32, 34, 99, 111, 110, 115, 111, 108, 101, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 103, 114, 111, 117, 112, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 103, 114, 111, 117, 112, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 103, 114, 111, 117, 112, 91, 105, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 99, 114, 101, 97, 116, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 79, 98, 106, 101, 99, 116, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 124, 124, 32, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 95, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 104, 97, 115, 73, 110, 106, 101, 99, 116, 101, 100, 77, 111, 100, 117, 108, 101, 40, 110, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 91, 110, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 77, 111, 100, 117, 108, 101, 40, 110, 97, 109, 101, 44, 32, 109, 111, 100, 117, 108, 101, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 104, 111, 115, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 91, 110, 97, 109, 101, 93, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 109, 111, 100, 117, 108, 101, 70, 117, 110, 99, 116, 105, 111, 110, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 69, 114, 114, 111, 114, 58, 32, 87, 101, 98, 32, 73, 110, 115, 112, 101, 99, 116, 111, 114, 58, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 119, 97, 115, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, 102, 111, 114, 32, 105, 110, 106, 101, 99, 116, 77, 111, 100, 117, 108, 101, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 111, 100, 117, 108, 101, 70, 117, 110, 99, 116, 105, 111, 110, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 44, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 44, 32, 116, 104, 105, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 34, 44, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 44, 32, 104, 111, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 109, 111, 100, 117, 108, 101, 115, 91, 110, 97, 109, 101, 93, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 111, 98, 106, 101, 99, 116, 73, 100, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 91, 111, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 98, 105, 110, 100, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 66, 111, 117, 110, 100, 79, 98, 106, 101, 99, 116, 73, 100, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 96, 123, 34, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 34, 58, 36, 123, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 125, 44, 34, 105, 100, 34, 58, 36, 123, 105, 100, 125, 125, 96, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 91, 105, 100, 93, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 103, 114, 111, 117, 112, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 115, 91, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 93, 32, 61, 32, 103, 114, 111, 117, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 103, 114, 111, 117, 112, 44, 32, 105, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 105, 100, 93, 32, 61, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 73, 100, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 105, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 87, 114, 97, 112, 112, 101, 100, 79, 98, 106, 101, 99, 116, 91, 105, 100, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 105, 100, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 102, 97, 108, 108, 98, 97, 99, 107, 87, 114, 97, 112, 112, 101, 114, 40, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 114, 101, 115, 111, 108, 118, 101, 67, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 40, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 46, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 99, 97, 108, 108, 65, 114, 103, 117, 109, 101, 110, 116, 74, 83, 79, 78, 46, 111, 98, 106, 101, 99, 116, 73, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 32, 124, 124, 32, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 91, 34, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 34, 93, 32, 33, 61, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 65, 114, 103, 117, 109, 101, 110, 116, 115, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 108, 111, 110, 103, 32, 116, 111, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 74, 97, 118, 97, 83, 99, 114, 105, 112, 116, 32, 119, 111, 114, 108, 100, 32, 97, 115, 32, 116, 104, 101, 32, 116, 97, 114, 103, 101, 116, 32, 111, 98, 106, 101, 99, 116, 46, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 65, 114, 103, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 102, 105, 110, 100, 32, 111, 98, 106, 101, 99, 116, 32, 119, 105, 116, 104, 32, 103, 105, 118, 101, 110, 32, 105, 100, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 101, 100, 65, 114, 103, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 118, 97, 108, 117, 97, 116, 101, 65, 110, 100, 87, 114, 97, 112, 40, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 65, 110, 100, 83, 97, 118, 101, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 40, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 119, 114, 97, 112, 65, 110, 100, 83, 97, 118, 101, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 102, 117, 110, 99, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 102, 117, 110, 99, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 119, 114, 97, 112, 67, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 44, 32, 102, 117, 110, 99, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 114, 101, 115, 117, 108, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 102, 117, 110, 99, 40, 41, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 44, 32, 114, 101, 116, 117, 114, 110, 66, 121, 86, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 32, 38, 38, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 46, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 116, 117, 114, 110, 79, 98, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 99, 114, 101, 97, 116, 101, 84, 104, 114, 111, 119, 110, 86, 97, 108, 117, 101, 40, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 118, 97, 108, 117, 97, 116, 101, 79, 110, 40, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 44, 32, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 99, 108, 117, 100, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 32, 61, 32, 116, 104, 105, 115, 46, 99, 114, 101, 97, 116, 101, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 79, 98, 106, 101, 99, 116, 40, 105, 115, 69, 118, 97, 108, 79, 110, 67, 97, 108, 108, 70, 114, 97, 109, 101, 32, 63, 32, 111, 98, 106, 101, 99, 116, 32, 58, 32, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 118, 97, 108, 70, 117, 110, 99, 116, 105, 111, 110, 46, 64, 99, 97, 108, 108, 40, 111, 98, 106, 101, 99, 116, 44, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 44, 32, 99, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 99, 97, 108, 108, 70, 114, 97, 109, 101, 70, 111, 114, 73, 100, 40, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 67, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 34, 40, 34, 32, 43, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 32, 43, 32, 34, 41, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 114, 100, 105, 110, 97, 108, 32, 61, 32, 112, 97, 114, 115, 101, 100, 67, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 91, 34, 111, 114, 100, 105, 110, 97, 108, 34, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 116, 111, 112, 67, 97, 108, 108, 70, 114, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 45, 45, 111, 114, 100, 105, 110, 97, 108, 32, 62, 61, 32, 48, 32, 38, 38, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 99, 97, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 73, 100, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 123, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 125, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 116, 104, 105, 115, 46, 95, 112, 97, 114, 115, 101, 79, 98, 106, 101, 99, 116, 73, 100, 40, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 111, 98, 106, 101, 99, 116, 70, 111, 114, 73, 100, 40, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 100, 84, 111, 79, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 91, 112, 97, 114, 115, 101, 100, 79, 98, 106, 101, 99, 116, 73, 100, 46, 105, 100, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 116, 97, 114, 116, 32, 61, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 32, 124, 124, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 117, 110, 116, 32, 61, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 32, 124, 124, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 32, 61, 32, 33, 115, 116, 97, 114, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 102, 111, 114, 69, 97, 99, 104, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 62, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 115, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 103, 101, 116, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 115, 101, 116, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 101, 116, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 101, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 115, 121, 109, 98, 111, 108, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 32, 38, 38, 32, 99, 111, 117, 110, 116, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 61, 32, 99, 111, 117, 110, 116, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 109, 101, 32, 33, 61, 61, 32, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 99, 111, 117, 110, 116, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 61, 32, 99, 111, 117, 110, 116, 41, 32, 63, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 32, 58, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 34, 44, 32, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 34, 44, 32, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 99, 111, 109, 112, 108, 101, 116, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 103, 101, 116, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 61, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 108, 101, 116, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 102, 111, 114, 69, 97, 99, 104, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 123, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 44, 32, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 125, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 112, 114, 111, 120, 121, 34, 32, 124, 124, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 114, 101, 102, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 32, 61, 32, 110, 101, 119, 32, 64, 83, 101, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 46, 64, 97, 100, 100, 40, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 114, 101, 97, 116, 101, 70, 97, 107, 101, 86, 97, 108, 117, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 110, 97, 109, 101, 44, 32, 115, 121, 109, 98, 111, 108, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 111, 98, 106, 101, 99, 116, 91, 110, 97, 109, 101, 93, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 119, 114, 105, 116, 97, 98, 108, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 119, 114, 105, 116, 97, 98, 108, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 99, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 99, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 115, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 41, 32, 38, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 101, 100, 87, 105, 116, 104, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 64, 99, 97, 116, 99, 104, 40, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 123, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 97, 115, 84, 104, 114, 111, 119, 110, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 115, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 114, 114, 111, 114, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 38, 38, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 115, 105, 98, 108, 101, 78, 97, 116, 105, 118, 101, 66, 105, 110, 100, 105, 110, 103, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 105, 115, 80, 114, 105, 118, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 46, 64, 104, 97, 115, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 80, 114, 111, 99, 101, 115, 115, 101, 100, 46, 64, 97, 100, 100, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 97, 109, 101, 32, 61, 32, 105, 115, 80, 114, 105, 118, 97, 116, 101, 32, 63, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 58, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 121, 109, 98, 111, 108, 32, 61, 32, 40, 33, 105, 115, 80, 114, 105, 118, 97, 116, 101, 32, 38, 38, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 41, 32, 63, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 32, 58, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 99, 114, 101, 97, 116, 101, 70, 97, 107, 101, 86, 97, 108, 117, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 110, 97, 109, 101, 44, 32, 115, 121, 109, 98, 111, 108, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 83, 116, 114, 105, 110, 103, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 41, 46, 64, 101, 110, 100, 115, 87, 105, 116, 104, 40, 34, 91, 110, 97, 116, 105, 118, 101, 32, 99, 111, 100, 101, 93, 92, 110, 125, 34, 41, 32, 124, 124, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 103, 101, 116, 32, 38, 38, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 104, 97, 115, 79, 119, 110, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 34, 103, 101, 116, 34, 41, 32, 38, 38, 32, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 101, 116, 32, 38, 38, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 104, 97, 115, 79, 119, 110, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 34, 115, 101, 116, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 99, 114, 101, 97, 116, 101, 70, 97, 107, 101, 86, 97, 108, 117, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 110, 97, 109, 101, 44, 32, 115, 121, 109, 98, 111, 108, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 102, 97, 107, 101, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 109, 101, 32, 61, 32, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 115, 121, 109, 98, 111, 108, 32, 61, 32, 115, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 118, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 80, 114, 105, 118, 97, 116, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 99, 101, 115, 115, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 65, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 65, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 32, 38, 38, 32, 64, 105, 115, 70, 105, 110, 105, 116, 101, 40, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 41, 32, 38, 38, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 111, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 32, 105, 115, 68, 101, 102, 105, 110, 101, 100, 40, 111, 41, 59, 32, 111, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 79, 102, 40, 111, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 32, 61, 32, 111, 32, 61, 61, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 105, 118, 97, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 103, 101, 116, 79, 119, 110, 80, 114, 105, 118, 97, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 40, 111, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 112, 114, 105, 118, 97, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 105, 118, 97, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 32, 61, 32, 112, 114, 105, 118, 97, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 105, 118, 97, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 65, 114, 114, 97, 121, 76, 105, 107, 101, 32, 38, 38, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 111, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 111, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 105, 41, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 40, 111, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 91, 105, 93, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 40, 111, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 112, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 112, 114, 111, 99, 101, 115, 115, 80, 114, 111, 112, 101, 114, 116, 121, 40, 111, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 83, 121, 109, 98, 111, 108, 115, 91, 105, 93, 44, 32, 105, 115, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 104, 111, 117, 108, 100, 66, 114, 101, 97, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 119, 114, 105, 116, 97, 98, 108, 101, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 99, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 115, 79, 119, 110, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 64, 98, 117, 105, 108, 116, 105, 110, 83, 101, 116, 73, 116, 101, 114, 97, 98, 108, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 45, 45, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 101, 110, 116, 114, 105, 101, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 118, 97, 108, 117, 101, 34, 44, 32, 118, 97, 108, 117, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 32, 38, 38, 32, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 105, 101, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 91, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 93, 32, 111, 102, 32, 64, 98, 117, 105, 108, 116, 105, 110, 77, 97, 112, 73, 116, 101, 114, 97, 98, 108, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 45, 45, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 101, 110, 116, 114, 105, 101, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 107, 101, 121, 34, 44, 32, 107, 101, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 32, 38, 38, 32, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 105, 101, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 87, 101, 97, 107, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 87, 101, 97, 107, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 116, 101, 114, 97, 116, 111, 114, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 115, 117, 98, 116, 121, 112, 101, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 83, 116, 97, 114, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 87, 101, 97, 107, 77, 97, 112, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 87, 101, 97, 107, 83, 101, 116, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 103, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 69, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 101, 116, 99, 104, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 34, 117, 110, 101, 120, 112, 101, 99, 116, 101, 100, 32, 116, 121, 112, 101, 34, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 115, 97, 118, 101, 82, 101, 115, 117, 108, 116, 40, 114, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 124, 124, 32, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 120, 105, 115, 116, 105, 110, 103, 73, 110, 100, 101, 120, 32, 61, 32, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 105, 110, 100, 101, 120, 79, 102, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 120, 105, 115, 116, 105, 110, 103, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 101, 120, 105, 115, 116, 105, 110, 103, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 91, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 93, 32, 61, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 49, 48, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 110, 101, 120, 116, 83, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 125, 59, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 34, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 49, 32, 60, 60, 32, 48, 44, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 78, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 49, 32, 60, 60, 32, 49, 44, 32, 47, 47, 10, 32, 32, 32, 32, 34, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 49, 32, 60, 60, 32, 50, 44, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 41, 59, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 34, 67, 111, 110, 116, 105, 110, 117, 101, 34, 44, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 105, 118, 97, 116, 101, 83, 121, 109, 98, 111, 108, 40, 34, 99, 111, 110, 116, 105, 110, 117, 101, 34, 41, 44, 10, 32, 32, 32, 32, 34, 83, 116, 111, 112, 34, 44, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 105, 118, 97, 116, 101, 83, 121, 109, 98, 111, 108, 40, 34, 115, 116, 111, 112, 34, 41, 44, 10, 41, 59, 10, 10, 118, 97, 114, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 32, 61, 32, 110, 101, 119, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 59, 10, 10, 47, 47, 10, 10, 108, 101, 116, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 99, 108, 97, 115, 115, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 101, 120, 116, 101, 110, 100, 115, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 10, 123, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 117, 112, 101, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 32, 38, 38, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 32, 38, 38, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 98, 105, 103, 105, 110, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 118, 97, 108, 117, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 34, 110, 117, 108, 108, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 98, 105, 103, 105, 110, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 111, 98, 106, 101, 99, 116, 73, 100, 32, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 98, 105, 110, 100, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 115, 117, 98, 116, 121, 112, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 110, 116, 101, 114, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 98, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 32, 63, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 32, 58, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 32, 124, 124, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 46, 115, 105, 122, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 77, 97, 112, 83, 105, 122, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 83, 101, 116, 83, 105, 122, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 99, 108, 97, 115, 115, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 32, 111, 98, 106, 101, 99, 116, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 32, 38, 38, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 112, 114, 111, 120, 121, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 112, 114, 111, 120, 121, 84, 97, 114, 103, 101, 116, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 114, 101, 102, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 119, 101, 97, 107, 82, 101, 102, 84, 97, 114, 103, 101, 116, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 111, 98, 106, 101, 99, 116, 71, 114, 111, 117, 112, 78, 97, 109, 101, 44, 32, 102, 111, 114, 99, 101, 86, 97, 108, 117, 101, 84, 121, 112, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 98, 101, 40, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 101, 114, 114, 111, 114, 40, 101, 120, 46, 109, 101, 115, 115, 97, 103, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 34, 60, 102, 97, 105, 108, 101, 100, 32, 116, 111, 32, 99, 111, 110, 118, 101, 114, 116, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 32, 116, 111, 32, 115, 116, 114, 105, 110, 103, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 40, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 32, 61, 32, 110, 101, 119, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 40, 118, 97, 108, 117, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 97, 108, 115, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 44, 32, 99, 111, 108, 117, 109, 110, 78, 97, 109, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 32, 38, 38, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 114, 101, 108, 101, 97, 115, 101, 79, 98, 106, 101, 99, 116, 40, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 108, 97, 115, 115, 80, 114, 111, 116, 111, 116, 121, 112, 101, 46, 111, 98, 106, 101, 99, 116, 73, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 112, 114, 101, 118, 105, 101, 119, 32, 124, 124, 32, 114, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 95, 101, 109, 112, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 110, 117, 108, 108, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 32, 124, 124, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 97, 114, 114, 97, 121, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 99, 105, 115, 101, 84, 121, 112, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 101, 99, 105, 115, 101, 84, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 99, 105, 115, 101, 84, 121, 112, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 46, 115, 112, 108, 105, 99, 101, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 32, 38, 38, 32, 64, 105, 115, 70, 105, 110, 105, 116, 101, 40, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 97, 114, 114, 97, 121, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 100, 101, 115, 99, 114, 105, 98, 101, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 114, 101, 103, 101, 120, 112, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 100, 97, 116, 101, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 101, 114, 114, 111, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 112, 114, 111, 120, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 80, 114, 111, 120, 121, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 114, 101, 102, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 87, 101, 97, 107, 82, 101, 102, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 110, 111, 100, 101, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 110, 111, 100, 101, 80, 114, 101, 118, 105, 101, 119, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 110, 116, 101, 114, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 108, 97, 115, 115, 78, 97, 109, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 32, 38, 38, 32, 64, 64, 116, 111, 83, 116, 114, 105, 110, 103, 84, 97, 103, 32, 105, 110, 32, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 46, 64, 64, 116, 111, 83, 116, 114, 105, 110, 103, 84, 97, 103, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 46, 116, 111, 83, 116, 114, 105, 110, 103, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 108, 97, 115, 115, 78, 97, 109, 101, 32, 61, 61, 61, 32, 34, 79, 98, 106, 101, 99, 116, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 32, 61, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 38, 38, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 108, 97, 115, 115, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 110, 111, 100, 101, 80, 114, 101, 118, 105, 101, 119, 40, 110, 111, 100, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 88, 77, 76, 68, 111, 99, 117, 109, 101, 110, 116, 32, 61, 32, 110, 111, 100, 101, 46, 111, 119, 110, 101, 114, 68, 111, 99, 117, 109, 101, 110, 116, 32, 38, 38, 32, 33, 33, 110, 111, 100, 101, 46, 111, 119, 110, 101, 114, 68, 111, 99, 117, 109, 101, 110, 116, 46, 120, 109, 108, 86, 101, 114, 115, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 61, 32, 105, 115, 88, 77, 76, 68, 111, 99, 117, 109, 101, 110, 116, 32, 63, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 78, 97, 109, 101, 32, 58, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 78, 97, 109, 101, 46, 116, 111, 76, 111, 119, 101, 114, 67, 97, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 110, 111, 100, 101, 46, 110, 111, 100, 101, 84, 121, 112, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 49, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 111, 100, 101, 46, 105, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 105, 100, 61, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 105, 100, 32, 43, 32, 34, 92, 34, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 111, 100, 101, 46, 99, 108, 97, 115, 115, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 99, 108, 97, 115, 115, 61, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 99, 108, 97, 115, 115, 76, 105, 115, 116, 46, 116, 111, 83, 116, 114, 105, 110, 103, 40, 41, 46, 114, 101, 112, 108, 97, 99, 101, 40, 47, 92, 115, 43, 47, 44, 32, 34, 32, 34, 41, 32, 43, 32, 34, 92, 34, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 111, 100, 101, 78, 97, 109, 101, 32, 61, 61, 61, 32, 34, 105, 110, 112, 117, 116, 34, 32, 38, 38, 32, 110, 111, 100, 101, 46, 116, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 116, 121, 112, 101, 61, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 116, 121, 112, 101, 32, 43, 32, 34, 92, 34, 62, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 62, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 51, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 32, 92, 34, 34, 32, 43, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 86, 97, 108, 117, 101, 32, 43, 32, 34, 92, 34, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 56, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 33, 45, 45, 34, 32, 43, 32, 110, 111, 100, 101, 46, 110, 111, 100, 101, 86, 97, 108, 117, 101, 32, 43, 32, 34, 45, 45, 62, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 49, 48, 58, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 60, 33, 68, 79, 67, 84, 89, 80, 69, 32, 34, 32, 43, 32, 110, 111, 100, 101, 78, 97, 109, 101, 32, 43, 32, 34, 62, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 111, 100, 101, 78, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 95, 105, 110, 105, 116, 105, 97, 108, 80, 114, 101, 118, 105, 101, 119, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 104, 105, 115, 46, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 44, 32, 116, 104, 105, 115, 46, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 124, 124, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 46, 118, 97, 108, 117, 101, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 108, 111, 115, 115, 108, 101, 115, 115, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 110, 117, 108, 108, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 115, 105, 122, 101, 34, 32, 105, 110, 32, 116, 104, 105, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 115, 105, 122, 101, 32, 61, 32, 116, 104, 105, 115, 46, 115, 105, 122, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 101, 109, 112, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 110, 105, 116, 105, 97, 108, 80, 114, 101, 118, 105, 101, 119, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 103, 101, 110, 101, 114, 97, 116, 101, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 101, 118, 105, 101, 119, 32, 61, 32, 116, 104, 105, 115, 46, 95, 105, 110, 105, 116, 105, 97, 108, 80, 114, 101, 118, 105, 101, 119, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 115, 84, 97, 98, 108, 101, 82, 111, 119, 115, 82, 101, 113, 117, 101, 115, 116, 32, 61, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 67, 111, 117, 110, 116, 32, 61, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 63, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 46, 108, 101, 110, 103, 116, 104, 32, 58, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 34, 44, 32, 105, 115, 84, 97, 98, 108, 101, 82, 111, 119, 115, 82, 101, 113, 117, 101, 115, 116, 32, 63, 32, 49, 48, 48, 48, 32, 58, 32, 109, 97, 120, 40, 53, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 67, 111, 117, 110, 116, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 110, 100, 101, 120, 101, 115, 34, 44, 32, 105, 115, 84, 97, 98, 108, 101, 82, 111, 119, 115, 82, 101, 113, 117, 101, 115, 116, 32, 63, 32, 49, 48, 48, 48, 32, 58, 32, 109, 97, 120, 40, 49, 48, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 67, 111, 117, 110, 116, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 109, 97, 112, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 119, 101, 97, 107, 115, 101, 116, 34, 32, 124, 124, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 105, 116, 101, 114, 97, 116, 111, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 95, 97, 112, 112, 101, 110, 100, 69, 110, 116, 114, 121, 80, 114, 101, 118, 105, 101, 119, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 112, 112, 101, 110, 100, 80, 114, 111, 112, 101, 114, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 44, 32, 105, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 91, 105, 93, 44, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 105, 110, 116, 101, 114, 110, 97, 108, 34, 44, 32, 116, 114, 117, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 101, 118, 105, 101, 119, 46, 101, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 102, 111, 114, 69, 97, 99, 104, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 77, 111, 100, 101, 46, 65, 108, 108, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 44, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 97, 112, 112, 101, 110, 100, 80, 114, 111, 112, 101, 114, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 115, 65, 115, 86, 97, 108, 117, 101, 115, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 105, 110, 99, 108, 117, 100, 101, 80, 114, 111, 116, 111, 34, 44, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 97, 112, 112, 101, 110, 100, 80, 114, 111, 112, 101, 114, 116, 121, 80, 114, 101, 118, 105, 101, 119, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 44, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 44, 32, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 123, 105, 110, 116, 101, 114, 110, 97, 108, 125, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 119, 97, 115, 84, 104, 114, 111, 119, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 110, 97, 109, 101, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 32, 61, 61, 61, 32, 34, 95, 95, 112, 114, 111, 116, 111, 95, 95, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 79, 98, 106, 101, 99, 116, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 82, 101, 103, 69, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 32, 38, 38, 32, 33, 105, 115, 85, 73, 110, 116, 51, 50, 40, 110, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 32, 38, 38, 32, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 79, 119, 110, 32, 38, 38, 32, 33, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 32, 124, 124, 32, 40, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 114, 101, 103, 101, 120, 112, 34, 32, 38, 38, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 110, 97, 116, 105, 118, 101, 71, 101, 116, 116, 101, 114, 41, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 38, 38, 32, 33, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 105, 110, 99, 108, 117, 100, 101, 115, 46, 64, 99, 97, 108, 108, 40, 102, 105, 114, 115, 116, 76, 101, 118, 101, 108, 75, 101, 121, 115, 44, 32, 110, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 112, 114, 111, 112, 101, 114, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 111, 83, 116, 114, 105, 110, 103, 40, 112, 114, 111, 112, 101, 114, 116, 121, 46, 110, 97, 109, 101, 32, 62, 62, 62, 32, 48, 41, 32, 61, 61, 61, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 110, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 105, 110, 100, 101, 120, 101, 115, 45, 45, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 45, 45, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 105, 110, 100, 101, 120, 101, 115, 32, 60, 32, 48, 32, 124, 124, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 84, 104, 114, 101, 115, 104, 111, 108, 100, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 83, 116, 111, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 105, 115, 80, 114, 105, 118, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 105, 115, 80, 114, 105, 118, 97, 116, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 116, 101, 114, 110, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 105, 110, 116, 101, 114, 110, 97, 108, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 112, 114, 101, 118, 105, 101, 119, 46, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 34, 97, 99, 99, 101, 115, 115, 111, 114, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 118, 97, 108, 117, 101, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 34, 111, 98, 106, 101, 99, 116, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 115, 117, 98, 116, 121, 112, 101, 34, 44, 32, 34, 110, 117, 108, 108, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 34, 110, 117, 108, 108, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 116, 121, 112, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 46, 101, 110, 117, 109, 101, 114, 97, 98, 108, 101, 32, 38, 38, 32, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 80, 114, 111, 112, 101, 114, 116, 121, 70, 101, 116, 99, 104, 65, 99, 116, 105, 111, 110, 46, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 105, 115, 72, 84, 77, 76, 65, 108, 108, 67, 111, 108, 108, 101, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 121, 112, 101, 32, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 115, 116, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 49, 48, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 118, 97, 108, 117, 101, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 115, 116, 114, 105, 110, 103, 34, 32, 38, 38, 32, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 116, 111, 83, 116, 114, 105, 110, 103, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 121, 109, 98, 111, 108, 40, 118, 97, 108, 117, 101, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 118, 97, 108, 117, 101, 34, 44, 32, 115, 121, 109, 98, 111, 108, 83, 116, 114, 105, 110, 103, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 110, 97, 109, 101, 34, 44, 32, 110, 97, 109, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 116, 121, 112, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 115, 117, 98, 116, 121, 112, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 32, 124, 124, 32, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 111, 98, 106, 101, 99, 116, 44, 32, 115, 101, 99, 111, 110, 100, 76, 101, 118, 101, 108, 75, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 118, 97, 108, 117, 101, 80, 114, 101, 118, 105, 101, 119, 32, 61, 32, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 32, 124, 124, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 99, 108, 97, 115, 115, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 99, 108, 97, 115, 115, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 34, 99, 108, 97, 115, 115, 32, 34, 32, 43, 32, 118, 97, 108, 117, 101, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 110, 111, 100, 101, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 110, 111, 100, 101, 80, 114, 101, 118, 105, 101, 119, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 100, 101, 115, 99, 114, 105, 98, 101, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 61, 32, 116, 104, 105, 115, 46, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 102, 117, 108, 108, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 114, 101, 103, 101, 120, 112, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 121, 46, 118, 97, 108, 117, 101, 32, 61, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 112, 112, 101, 110, 100, 80, 114, 101, 118, 105, 101, 119, 40, 112, 114, 111, 112, 101, 114, 116, 121, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 97, 112, 112, 101, 110, 100, 69, 110, 116, 114, 121, 80, 114, 101, 118, 105, 101, 119, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 101, 118, 105, 101, 119, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 101, 110, 116, 114, 105, 101, 115, 40, 111, 98, 106, 101, 99, 116, 44, 32, 116, 104, 105, 115, 46, 115, 117, 98, 116, 121, 112, 101, 44, 32, 48, 44, 32, 54, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 53, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 112, 111, 112, 46, 64, 99, 97, 108, 108, 40, 101, 110, 116, 114, 105, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 111, 118, 101, 114, 102, 108, 111, 119, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 117, 112, 100, 97, 116, 101, 77, 97, 105, 110, 80, 114, 101, 118, 105, 101, 119, 40, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 117, 98, 80, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 108, 111, 115, 115, 108, 101, 115, 115, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 101, 119, 46, 101, 110, 116, 114, 105, 101, 115, 32, 61, 32, 64, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 109, 97, 112, 46, 64, 99, 97, 108, 108, 40, 101, 110, 116, 114, 105, 101, 115, 44, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 44, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 117, 112, 100, 97, 116, 101, 77, 97, 105, 110, 80, 114, 101, 118, 105, 101, 119, 40, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 34, 107, 101, 121, 34, 32, 105, 110, 32, 101, 110, 116, 114, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 80, 114, 101, 118, 105, 101, 119, 70, 111, 114, 86, 97, 108, 117, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 32, 33, 61, 61, 32, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 117, 112, 100, 97, 116, 101, 77, 97, 105, 110, 80, 114, 101, 118, 105, 101, 119, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 40, 118, 97, 108, 117, 101, 44, 32, 111, 98, 106, 101, 99, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 101, 116, 32, 61, 32, 110, 101, 119, 32, 64, 83, 101, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 101, 116, 46, 64, 97, 100, 100, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 118, 97, 108, 117, 101, 44, 32, 115, 101, 116, 44, 32, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 111, 98, 106, 101, 99, 116, 44, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 44, 32, 100, 101, 112, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 62, 32, 51, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 80, 114, 105, 109, 105, 116, 105, 118, 101, 86, 97, 108, 117, 101, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 105, 115, 66, 105, 103, 73, 110, 116, 40, 111, 98, 106, 101, 99, 116, 41, 32, 124, 124, 32, 105, 115, 83, 121, 109, 98, 111, 108, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 46, 64, 104, 97, 115, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 100, 101, 112, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 46, 64, 97, 100, 100, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 117, 98, 116, 121, 112, 101, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 115, 117, 98, 116, 121, 112, 101, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 117, 98, 116, 121, 112, 101, 32, 61, 61, 61, 32, 34, 97, 114, 114, 97, 121, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 111, 98, 106, 101, 99, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 62, 32, 53, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 111, 98, 106, 101, 99, 116, 91, 105, 93, 44, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 44, 32, 100, 101, 112, 116, 104, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 32, 38, 38, 32, 111, 98, 106, 101, 99, 116, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 46, 95, 95, 112, 114, 111, 116, 111, 95, 95, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 51, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 32, 61, 32, 111, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 40, 111, 98, 106, 101, 99, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 38, 38, 32, 33, 40, 34, 118, 97, 108, 117, 101, 34, 32, 105, 110, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 95, 105, 115, 80, 114, 101, 118, 105, 101, 119, 97, 98, 108, 101, 79, 98, 106, 101, 99, 116, 73, 110, 116, 101, 114, 110, 97, 108, 40, 111, 98, 106, 101, 99, 116, 91, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 93, 44, 32, 107, 110, 111, 119, 110, 79, 98, 106, 101, 99, 116, 115, 44, 32, 100, 101, 112, 116, 104, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 97, 98, 98, 114, 101, 118, 105, 97, 116, 101, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 44, 32, 109, 105, 100, 100, 108, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 60, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 105, 100, 100, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 108, 101, 102, 116, 72, 97, 108, 102, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 62, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 114, 105, 103, 104, 116, 72, 97, 108, 102, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 108, 101, 102, 116, 72, 97, 108, 102, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 46, 64, 115, 117, 98, 115, 116, 114, 40, 48, 44, 32, 108, 101, 102, 116, 72, 97, 108, 102, 41, 32, 43, 32, 34, 92, 117, 50, 48, 50, 54, 34, 32, 43, 32, 115, 116, 114, 105, 110, 103, 46, 64, 115, 117, 98, 115, 116, 114, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 114, 105, 103, 104, 116, 72, 97, 108, 102, 44, 32, 114, 105, 103, 104, 116, 72, 97, 108, 102, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 46, 64, 115, 117, 98, 115, 116, 114, 40, 48, 44, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 32, 43, 32, 34, 92, 117, 50, 48, 50, 54, 34, 59, 10, 32, 32, 32, 32, 125, 10, 125, 59, 10, 10, 47, 47, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 32, 61, 32, 99, 108, 97, 115, 115, 32, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 32, 101, 120, 116, 101, 110, 100, 115, 32, 80, 114, 111, 116, 111, 116, 121, 112, 101, 108, 101, 115, 115, 79, 98, 106, 101, 99, 116, 66, 97, 115, 101, 10, 123, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 111, 114, 100, 105, 110, 97, 108, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 117, 112, 101, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 99, 97, 108, 108, 70, 114, 97, 109, 101, 73, 100, 32, 61, 32, 96, 123, 34, 111, 114, 100, 105, 110, 97, 108, 34, 58, 36, 123, 111, 114, 100, 105, 110, 97, 108, 125, 44, 34, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 34, 58, 36, 123, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 73, 100, 125, 125, 96, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 102, 117, 110, 99, 116, 105, 111, 110, 78, 97, 109, 101, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 102, 117, 110, 99, 116, 105, 111, 110, 78, 97, 109, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 111, 99, 97, 116, 105, 111, 110, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 115, 99, 114, 105, 112, 116, 73, 100, 34, 44, 32, 64, 83, 116, 114, 105, 110, 103, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 115, 111, 117, 114, 99, 101, 73, 68, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 108, 105, 110, 101, 78, 117, 109, 98, 101, 114, 34, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 108, 105, 110, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 99, 111, 108, 117, 109, 110, 78, 117, 109, 98, 101, 114, 34, 44, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 99, 111, 108, 117, 109, 110, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 32, 61, 32, 116, 104, 105, 115, 46, 95, 119, 114, 97, 112, 83, 99, 111, 112, 101, 67, 104, 97, 105, 110, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 116, 104, 105, 115, 32, 61, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 116, 104, 105, 115, 79, 98, 106, 101, 99, 116, 44, 32, 34, 98, 97, 99, 107, 116, 114, 97, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 105, 115, 84, 97, 105, 108, 68, 101, 108, 101, 116, 101, 100, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 105, 115, 84, 97, 105, 108, 68, 101, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 95, 119, 114, 97, 112, 83, 99, 111, 112, 101, 67, 104, 97, 105, 110, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 115, 32, 61, 32, 99, 97, 108, 108, 70, 114, 97, 109, 101, 46, 115, 99, 111, 112, 101, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 115, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 80, 114, 111, 120, 121, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 114, 97, 121, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 80, 114, 111, 120, 121, 91, 105, 93, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 46, 95, 99, 114, 101, 97, 116, 101, 83, 99, 111, 112, 101, 74, 115, 111, 110, 40, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 91, 105, 93, 44, 32, 115, 99, 111, 112, 101, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 115, 91, 105, 93, 44, 32, 34, 98, 97, 99, 107, 116, 114, 97, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 99, 111, 112, 101, 67, 104, 97, 105, 110, 80, 114, 111, 120, 121, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 115, 116, 97, 116, 105, 99, 32, 95, 99, 114, 101, 97, 116, 101, 83, 99, 111, 112, 101, 74, 115, 111, 110, 40, 111, 98, 106, 101, 99, 116, 44, 32, 123, 110, 97, 109, 101, 44, 32, 116, 121, 112, 101, 44, 32, 108, 111, 99, 97, 116, 105, 111, 110, 125, 44, 32, 103, 114, 111, 117, 112, 73, 100, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 115, 99, 111, 112, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 111, 98, 106, 101, 99, 116, 34, 44, 32, 82, 101, 109, 111, 116, 101, 79, 98, 106, 101, 99, 116, 46, 99, 114, 101, 97, 116, 101, 40, 111, 98, 106, 101, 99, 116, 44, 32, 103, 114, 111, 117, 112, 73, 100, 41, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 34, 116, 121, 112, 101, 34, 44, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 46, 95, 115, 99, 111, 112, 101, 84, 121, 112, 101, 78, 97, 109, 101, 115, 91, 116, 121, 112, 101, 93, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 46, 110, 97, 109, 101, 32, 61, 32, 110, 97, 109, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 111, 99, 97, 116, 105, 111, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 46, 108, 111, 99, 97, 116, 105, 111, 110, 32, 61, 32, 108, 111, 99, 97, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 69, 109, 112, 116, 121, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 99, 111, 112, 101, 46, 101, 109, 112, 116, 121, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 99, 111, 112, 101, 59, 10, 32, 32, 32, 32, 125, 10, 125, 59, 10, 10, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 67, 97, 108, 108, 70, 114, 97, 109, 101, 80, 114, 111, 120, 121, 46, 95, 115, 99, 111, 112, 101, 84, 121, 112, 101, 78, 97, 109, 101, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 10, 32, 32, 32, 32, 48, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 49, 44, 32, 34, 119, 105, 116, 104, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 50, 44, 32, 34, 99, 108, 111, 115, 117, 114, 101, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 51, 44, 32, 34, 99, 97, 116, 99, 104, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 52, 44, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 78, 97, 109, 101, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 53, 44, 32, 34, 103, 108, 111, 98, 97, 108, 76, 101, 120, 105, 99, 97, 108, 69, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 34, 44, 32, 47, 47, 10, 32, 32, 32, 32, 54, 44, 32, 34, 110, 101, 115, 116, 101, 100, 76, 101, 120, 105, 99, 97, 108, 34, 44, 32, 47, 47, 10, 41, 59, 10, 10, 47, 47, 10, 10, 102, 117, 110, 99, 116, 105, 111, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 40, 99, 97, 108, 108, 70, 114, 97, 109, 101, 41, 10, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 61, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 59, 10, 10, 32, 32, 32, 32, 108, 101, 116, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 32, 61, 32, 40, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 44, 32, 119, 114, 97, 112, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 119, 114, 97, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 116, 32, 111, 114, 105, 103, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 111, 114, 105, 103, 105, 110, 97, 108, 86, 97, 108, 117, 101, 59, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 100, 101, 102, 105, 110, 101, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 104, 105, 115, 44, 32, 34, 36, 34, 32, 43, 32, 107, 101, 121, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 103, 101, 116, 34, 44, 32, 118, 97, 108, 117, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 38, 38, 32, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 33, 61, 61, 32, 34, 36, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 100, 101, 102, 105, 110, 101, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 104, 105, 115, 44, 32, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 65, 108, 105, 97, 115, 32, 43, 32, 107, 101, 121, 44, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 34, 103, 101, 116, 34, 44, 32, 118, 97, 108, 117, 101, 41, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 34, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 34, 32, 105, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 34, 95, 34, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 108, 97, 115, 116, 82, 101, 115, 117, 108, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 34, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 34, 32, 105, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 34, 101, 120, 99, 101, 112, 116, 105, 111, 110, 34, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 101, 120, 99, 101, 112, 116, 105, 111, 110, 86, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 34, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 34, 32, 105, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 34, 101, 118, 101, 110, 116, 34, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 101, 118, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 105, 44, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 95, 115, 97, 118, 101, 100, 82, 101, 115, 117, 108, 116, 115, 91, 105, 93, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 110, 97, 109, 101, 32, 105, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 103, 101, 116, 116, 101, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 105, 110, 101, 71, 101, 116, 116, 101, 114, 40, 110, 97, 109, 101, 44, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 103, 101, 116, 116, 101, 114, 115, 91, 110, 97, 109, 101, 93, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 110, 97, 109, 101, 32, 105, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 91, 110, 97, 109, 101, 93, 32, 61, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 110, 97, 109, 101, 93, 59, 10, 125, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 103, 101, 116, 116, 101, 114, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 40, 41, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 107, 101, 121, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 107, 101, 121, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 118, 97, 108, 117, 101, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 118, 97, 108, 117, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 32, 125, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 113, 117, 101, 114, 121, 73, 110, 115, 116, 97, 110, 99, 101, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 113, 117, 101, 114, 121, 73, 110, 115, 116, 97, 110, 99, 101, 115, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 113, 117, 101, 114, 121, 79, 98, 106, 101, 99, 116, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 113, 117, 101, 114, 121, 73, 110, 115, 116, 97, 110, 99, 101, 115, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 113, 117, 101, 114, 121, 72, 111, 108, 100, 101, 114, 115, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 73, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 72, 111, 115, 116, 46, 113, 117, 101, 114, 121, 72, 111, 108, 100, 101, 114, 115, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 105, 110, 115, 112, 101, 99, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 111, 98, 106, 101, 99, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 46, 105, 110, 115, 112, 101, 99, 116, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 41, 59, 32, 125, 59, 10, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 97, 115, 115, 101, 114, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 97, 115, 115, 101, 114, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 99, 108, 101, 97, 114, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 99, 108, 101, 97, 114, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 99, 111, 117, 110, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 99, 111, 117, 110, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 99, 111, 117, 110, 116, 82, 101, 115, 101, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 99, 111, 117, 110, 116, 82, 101, 115, 101, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 100, 101, 98, 117, 103, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 100, 101, 98, 117, 103, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 100, 105, 114, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 100, 105, 114, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 100, 105, 114, 120, 109, 108, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 100, 105, 114, 120, 109, 108, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 101, 114, 114, 111, 114, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 101, 114, 114, 111, 114, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 103, 114, 111, 117, 112, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 103, 114, 111, 117, 112, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 103, 114, 111, 117, 112, 67, 111, 108, 108, 97, 112, 115, 101, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 103, 114, 111, 117, 112, 67, 111, 108, 108, 97, 112, 115, 101, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 103, 114, 111, 117, 112, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 103, 114, 111, 117, 112, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 105, 110, 102, 111, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 105, 110, 102, 111, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 108, 111, 103, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 108, 111, 103, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 112, 114, 111, 102, 105, 108, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 112, 114, 111, 102, 105, 108, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 112, 114, 111, 102, 105, 108, 101, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 112, 114, 111, 102, 105, 108, 101, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 114, 101, 99, 111, 114, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 114, 101, 99, 111, 114, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 114, 101, 99, 111, 114, 100, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 114, 101, 99, 111, 114, 100, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 115, 99, 114, 101, 101, 110, 115, 104, 111, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 115, 99, 114, 101, 101, 110, 115, 104, 111, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 97, 98, 108, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 97, 98, 108, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 97, 107, 101, 72, 101, 97, 112, 83, 110, 97, 112, 115, 104, 111, 116, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 97, 107, 101, 72, 101, 97, 112, 83, 110, 97, 112, 115, 104, 111, 116, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 69, 110, 100, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 69, 110, 100, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 76, 111, 103, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 76, 111, 103, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 105, 109, 101, 83, 116, 97, 109, 112, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 105, 109, 101, 83, 116, 97, 109, 112, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 116, 114, 97, 99, 101, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 116, 114, 97, 99, 101, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 34, 119, 97, 114, 110, 34, 93, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 112, 101, 99, 116, 101, 100, 71, 108, 111, 98, 97, 108, 79, 98, 106, 101, 99, 116, 46, 99, 111, 110, 115, 111, 108, 101, 46, 119, 97, 114, 110, 40, 46, 46, 46, 99, 114, 101, 97, 116, 101, 73, 116, 101, 114, 97, 98, 108, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 70, 114, 111, 109, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 32, 125, 59, 10, 10, 102, 111, 114, 32, 40, 108, 101, 116, 32, 110, 97, 109, 101, 32, 105, 110, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 41, 10, 32, 32, 32, 32, 67, 111, 109, 109, 97, 110, 100, 76, 105, 110, 101, 65, 80, 73, 46, 109, 101, 116, 104, 111, 100, 115, 91, 110, 97, 109, 101, 93, 46, 116, 111, 83, 116, 114, 105, 110, 103, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 32, 34, 32, 43, 32, 110, 97, 109, 101, 32, 43, 32, 34, 40, 41, 32, 123, 32, 91, 67, 111, 109, 109, 97, 110, 100, 32, 76, 105, 110, 101, 32, 65, 80, 73, 93, 32, 125, 34, 59, 32, 125, 59, 10, 10, 114, 101, 116, 117, 114, 110, 32, 105, 110, 106, 101, 99, 116, 101, 100, 83, 99, 114, 105, 112, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 37, 32, 50, 32, 33, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 96, 99, 114, 101, 97, 116, 101, 79, 98, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 96, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 101, 97, 99, 104, 32, 107, 101, 121, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 102, 111, 108, 108, 111, 119, 101, 100, 32, 98, 121, 32, 97, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 108, 116, 105, 110, 103, 32, 105, 110, 32, 97, 110, 32, 101, 118, 101, 110, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 108, 101, 116, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 108, 101, 116, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 43, 61, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 98, 106, 101, 99, 116, 91, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 93, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 32, 43, 32, 49, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 101, 114, 114, 111, 114, 41, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 44, 32, 109, 97, 112, 70, 110, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 65, 115, 121, 110, 99, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 119, 97, 105, 116, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 119, 97, 105, 116, 32, 40, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 116, 111, 114, 44, 32, 109, 97, 112, 70, 110, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 41, 32, 58, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 97, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 97, 119, 97, 105, 116, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 119, 97, 105, 116, 32, 40, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 107, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 100, 101, 108, 101, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 108, 101, 116, 101, 32, 116, 97, 114, 103, 101, 116, 91, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 93, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 32, 124, 124, 32, 33, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 64, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 46, 107, 101, 121, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 100, 105, 102, 102, 101, 114, 101, 110, 99, 101, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 100, 105, 102, 102, 101, 114, 101, 110, 99, 101, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 115, 101, 116, 67, 108, 111, 110, 101, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 115, 105, 122, 101, 32, 60, 61, 32, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 100, 101, 108, 101, 116, 101, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 107, 101, 121, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 101, 121, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 104, 97, 115, 40, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 100, 101, 108, 101, 116, 101, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 32, 38, 38, 32, 64, 105, 115, 83, 117, 115, 112, 101, 110, 100, 89, 105, 101, 108, 100, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 82, 101, 116, 117, 114, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 115, 111, 110, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 78, 111, 114, 109, 97, 108, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 32, 61, 32, 64, 110, 101, 119, 82, 101, 103, 105, 115, 116, 114, 121, 69, 110, 116, 114, 121, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 115, 101, 116, 40, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 101, 118, 97, 108, 117, 97, 116, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 32, 33, 61, 61, 32, 39, 115, 116, 114, 105, 110, 103, 39, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 101, 118, 97, 108, 117, 97, 116, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 124, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 124, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 32, 115, 116, 114, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 82, 101, 109, 111, 116, 101, 86, 97, 108, 117, 101, 40, 116, 114, 117, 101, 44, 32, 116, 104, 105, 115, 44, 32, 64, 101, 118, 97, 108, 73, 110, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 44, 32, 115, 111, 117, 114, 99, 101, 84, 101, 120, 116, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 101, 110, 100, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 97, 108, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 110, 97, 108, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 110, 97, 108, 32, 62, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 102, 105, 110, 97, 108, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 112, 101, 99, 105, 101, 115, 40, 48, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 99, 117, 114, 114, 101, 110, 116, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 120, 116, 73, 110, 100, 101, 120, 44, 32, 99, 117, 114, 114, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 110, 101, 120, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 112, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 107, 101, 112, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 107, 101, 112, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 116, 104, 105, 115, 41, 32, 33, 61, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 102, 114, 111, 109, 32, 124, 116, 104, 105, 115, 124, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 107, 101, 112, 116, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 40, 48, 44, 32, 32, 40, 118, 97, 108, 117, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 40, 41, 32, 61, 62, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 40, 48, 44, 32, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 40, 41, 32, 61, 62, 32, 123, 32, 116, 104, 114, 111, 119, 32, 114, 101, 97, 115, 111, 110, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 116, 104, 101, 110, 40, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 86, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 107, 86, 97, 108, 117, 101, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 107, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 32, 105, 32, 62, 61, 32, 48, 59, 32, 105, 45, 45, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 120, 101, 100, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 116, 116, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 116, 104, 78, 117, 109, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 116, 104, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 116, 104, 78, 117, 109, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 100, 101, 112, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 112, 101, 99, 105, 101, 115, 40, 48, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 10, 32, 32, 32, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 114, 101, 115, 117, 108, 116, 44, 32, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 44, 32, 100, 101, 112, 116, 104, 78, 117, 109, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 100, 101, 112, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 60, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 105, 110, 32, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 115, 111, 117, 114, 99, 101, 91, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 62, 32, 48, 32, 38, 38, 32, 64, 105, 115, 65, 114, 114, 97, 121, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 101, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 100, 101, 112, 116, 104, 32, 45, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 102, 108, 97, 116, 116, 101, 110, 32, 97, 114, 114, 97, 121, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 101, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 60, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 105, 110, 32, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 115, 111, 117, 114, 99, 101, 91, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 93, 44, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 65, 114, 114, 97, 121, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 101, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 102, 108, 97, 116, 116, 101, 110, 32, 97, 114, 114, 97, 121, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 101, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 77, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 77, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 112, 101, 99, 105, 101, 115, 40, 48, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 87, 105, 116, 104, 67, 97, 108, 108, 98, 97, 99, 107, 40, 114, 101, 115, 117, 108, 116, 44, 32, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 108, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 110, 116, 99, 111, 108, 111, 114, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 102, 111, 110, 116, 34, 44, 32, 34, 99, 111, 108, 111, 114, 34, 44, 32, 99, 111, 108, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 105, 122, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 110, 116, 115, 105, 122, 101, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 102, 111, 110, 116, 34, 44, 32, 34, 115, 105, 122, 101, 34, 44, 32, 115, 105, 122, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 77, 97, 112, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 77, 97, 112, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 86, 97, 108, 117, 101, 40, 98, 117, 99, 107, 101, 116, 41, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 107, 101, 121, 44, 32, 107, 101, 121, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 109, 97, 112, 70, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 109, 97, 112, 70, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 70, 114, 111, 109, 70, 97, 115, 116, 40, 116, 104, 105, 115, 44, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 109, 115, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 41, 32, 58, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 109, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 109, 97, 112, 70, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 44, 32, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 109, 97, 112, 70, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 70, 114, 111, 109, 70, 97, 115, 116, 40, 116, 104, 105, 115, 44, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 115, 116, 82, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 109, 115, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 109, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 99, 111, 117, 110, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 99, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 99, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 32, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 109, 97, 112, 70, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 65, 115, 121, 110, 99, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 117, 115, 105, 110, 103, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 117, 115, 105, 110, 103, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 46, 64, 64, 97, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 117, 115, 105, 110, 103, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 117, 115, 105, 110, 103, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 65, 115, 121, 110, 99, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 97, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 117, 115, 105, 110, 103, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 117, 115, 105, 110, 103, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 117, 115, 105, 110, 103, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 65, 115, 121, 110, 99, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 117, 115, 105, 110, 103, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 101, 102, 97, 117, 108, 116, 65, 115, 121, 110, 99, 70, 114, 111, 109, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 117, 115, 105, 110, 103, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 64, 99, 97, 108, 108, 40, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 41, 44, 32, 109, 97, 112, 70, 110, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 117, 115, 105, 110, 103, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 117, 115, 105, 110, 103, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 64, 99, 97, 108, 108, 40, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 101, 102, 97, 117, 108, 116, 65, 115, 121, 110, 99, 70, 114, 111, 109, 65, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 64, 99, 114, 101, 97, 116, 101, 65, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 40, 105, 116, 101, 114, 97, 116, 111, 114, 44, 32, 105, 116, 101, 114, 97, 116, 111, 114, 46, 110, 101, 120, 116, 41, 44, 32, 109, 97, 112, 70, 110, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 101, 102, 97, 117, 108, 116, 65, 115, 121, 110, 99, 70, 114, 111, 109, 65, 115, 121, 110, 99, 65, 114, 114, 97, 121, 76, 105, 107, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 97, 115, 121, 110, 99, 73, 116, 101, 109, 115, 44, 32, 109, 97, 112, 70, 110, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 123, 125, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 101, 110, 116, 114, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 79, 98, 106, 101, 99, 116, 46, 102, 114, 111, 109, 69, 110, 116, 114, 105, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 105, 116, 101, 114, 97, 98, 108, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 121, 105, 101, 108, 100, 115, 32, 111, 98, 106, 101, 99, 116, 115, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 101, 110, 116, 114, 121, 91, 48, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 101, 110, 116, 114, 121, 91, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 115, 111, 117, 114, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 102, 111, 114, 99, 101, 70, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 64, 116, 114, 105, 103, 103, 101, 114, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 118, 97, 108, 117, 101, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 84, 104, 105, 115, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 84, 104, 105, 115, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 103, 101, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 60, 32, 51, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 91, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 93, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 99, 101, 105, 118, 101, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 116, 66, 121, 86, 97, 108, 87, 105, 116, 104, 84, 104, 105, 115, 40, 116, 97, 114, 103, 101, 116, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 111, 116, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 111, 116, 104, 101, 114, 46, 115, 105, 122, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 105, 122, 101, 32, 33, 61, 61, 32, 115, 105, 122, 101, 41, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 104, 97, 118, 101, 32, 110, 111, 110, 45, 78, 97, 78, 32, 39, 115, 105, 122, 101, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 73, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 115, 105, 122, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 105, 122, 101, 73, 110, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 104, 97, 118, 101, 32, 110, 111, 110, 45, 110, 101, 103, 97, 116, 105, 118, 101, 32, 39, 115, 105, 122, 101, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 105, 122, 101, 73, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 116, 99, 104, 101, 100, 44, 32, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 116, 99, 104, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 105, 108, 80, 111, 115, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 32, 61, 32, 99, 97, 112, 116, 117, 114, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 116, 97, 114, 116, 32, 61, 32, 48, 59, 32, 115, 116, 97, 114, 116, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 79, 102, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 34, 36, 34, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 41, 44, 32, 115, 116, 97, 114, 116, 32, 33, 61, 61, 32, 45, 49, 59, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 61, 32, 115, 116, 97, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 45, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 62, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 104, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 91, 115, 116, 97, 114, 116, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 36, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 38, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 109, 97, 116, 99, 104, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 96, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 48, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 39, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 105, 108, 80, 111, 115, 32, 60, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 116, 97, 105, 108, 80, 111, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 60, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 32, 61, 32, 115, 116, 97, 114, 116, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 79, 102, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 34, 62, 34, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 32, 61, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 91, 103, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 116, 117, 114, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 97, 112, 116, 117, 114, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 32, 61, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 60, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 104, 67, 111, 100, 101, 32, 61, 32, 99, 104, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 104, 67, 111, 100, 101, 32, 62, 61, 32, 48, 120, 51, 48, 32, 38, 38, 32, 99, 104, 67, 111, 100, 101, 32, 60, 61, 32, 48, 120, 51, 57, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 115, 116, 97, 114, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 32, 61, 32, 99, 104, 67, 111, 100, 101, 32, 45, 32, 48, 120, 51, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 32, 62, 32, 109, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 60, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 62, 61, 32, 48, 120, 51, 48, 32, 38, 38, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 60, 61, 32, 48, 120, 51, 57, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 110, 32, 61, 32, 49, 48, 32, 42, 32, 110, 32, 43, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 45, 32, 48, 120, 51, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 110, 32, 60, 61, 32, 109, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 32, 61, 32, 110, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 32, 61, 61, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 32, 61, 32, 99, 97, 112, 116, 117, 114, 101, 115, 91, 110, 32, 45, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 116, 117, 114, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 99, 97, 112, 116, 117, 114, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 103, 114, 111, 117, 112, 66, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 103, 114, 111, 117, 112, 66, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 115, 32, 61, 32, 110, 101, 119, 32, 64, 77, 97, 112, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 116, 101, 109, 32, 111, 102, 32, 105, 116, 101, 109, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 105, 116, 101, 109, 44, 32, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 32, 61, 32, 103, 114, 111, 117, 112, 115, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 115, 46, 64, 115, 101, 116, 40, 107, 101, 121, 44, 32, 103, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 103, 114, 111, 117, 112, 44, 32, 103, 114, 111, 117, 112, 46, 108, 101, 110, 103, 116, 104, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 107, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 103, 114, 111, 117, 112, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 79, 98, 106, 101, 99, 116, 46, 103, 114, 111, 117, 112, 66, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 79, 98, 106, 101, 99, 116, 46, 103, 114, 111, 117, 112, 66, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 116, 101, 109, 32, 111, 102, 32, 105, 116, 101, 109, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 116, 111, 80, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 105, 116, 101, 109, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 32, 61, 32, 103, 114, 111, 117, 112, 115, 91, 107, 101, 121, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 114, 111, 117, 112, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 103, 114, 111, 117, 112, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 103, 114, 111, 117, 112, 115, 44, 32, 107, 101, 121, 44, 32, 103, 114, 111, 117, 112, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 103, 114, 111, 117, 112, 44, 32, 103, 114, 111, 117, 112, 46, 108, 101, 110, 103, 116, 104, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 107, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 103, 114, 111, 117, 112, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 104, 97, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 32, 105, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 70, 108, 97, 103, 115, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 102, 108, 97, 103, 115, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 70, 108, 97, 103, 115, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 70, 108, 97, 103, 115, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 105, 103, 110, 111, 114, 101, 67, 97, 115, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 77, 117, 108, 116, 105, 108, 105, 110, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 109, 117, 108, 116, 105, 108, 105, 110, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 77, 117, 108, 116, 105, 108, 105, 110, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 77, 117, 108, 116, 105, 108, 105, 110, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 116, 105, 99, 107, 121, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 115, 116, 105, 99, 107, 121, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 116, 105, 99, 107, 121, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 83, 116, 105, 99, 107, 121, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 111, 117, 114, 99, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 115, 111, 117, 114, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 111, 117, 114, 99, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 83, 111, 117, 114, 99, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 121, 109, 98, 111, 108, 77, 97, 116, 99, 104, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 87, 105, 116, 104, 87, 101, 108, 108, 75, 110, 111, 119, 110, 83, 121, 109, 98, 111, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 109, 97, 116, 99, 104, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 121, 109, 98, 111, 108, 77, 97, 116, 99, 104, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 116, 121, 112, 101, 83, 121, 109, 98, 111, 108, 77, 97, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 108, 97, 99, 101, 114, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 116, 121, 112, 101, 83, 121, 109, 98, 111, 108, 82, 101, 112, 108, 97, 99, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 83, 101, 116, 115, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 112, 101, 99, 105, 102, 105, 101, 114, 44, 32, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 105, 109, 112, 111, 114, 116, 86, 97, 108, 117, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 114, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 112, 101, 99, 105, 102, 105, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 32, 33, 61, 61, 32, 39, 115, 116, 114, 105, 110, 103, 39, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 96, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 105, 109, 112, 111, 114, 116, 86, 97, 108, 117, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 124, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 124, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 32, 115, 116, 114, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 111, 107, 117, 112, 66, 105, 110, 100, 105, 110, 103, 32, 61, 32, 40, 109, 111, 100, 117, 108, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 111, 107, 117, 112, 32, 61, 32, 109, 111, 100, 117, 108, 101, 91, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 111, 111, 107, 117, 112, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 37, 46, 105, 109, 112, 111, 114, 116, 86, 97, 108, 117, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 101, 120, 112, 111, 114, 116, 78, 97, 109, 101, 124, 32, 116, 111, 32, 101, 120, 105, 115, 116, 32, 105, 110, 32, 116, 104, 101, 32, 124, 115, 112, 101, 99, 105, 102, 105, 101, 114, 124, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 114, 97, 112, 82, 101, 109, 111, 116, 101, 86, 97, 108, 117, 101, 40, 116, 114, 117, 101, 44, 32, 116, 104, 105, 115, 44, 32, 108, 111, 111, 107, 117, 112, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 109, 112, 111, 114, 116, 73, 110, 82, 101, 97, 108, 109, 40, 116, 104, 105, 115, 44, 32, 115, 112, 101, 99, 105, 102, 105, 101, 114, 83, 116, 114, 105, 110, 103, 41, 46, 64, 116, 104, 101, 110, 40, 108, 111, 111, 107, 117, 112, 66, 105, 110, 100, 105, 110, 103, 44, 32, 64, 99, 114, 111, 115, 115, 82, 101, 97, 108, 109, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 110, 99, 108, 117, 100, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 102, 114, 111, 109, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 62, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 61, 61, 61, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 124, 124, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 33, 61, 61, 32, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 38, 38, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 33, 61, 61, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 109, 112, 111, 114, 116, 79, 98, 106, 101, 99, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 80, 114, 111, 109, 105, 115, 101, 46, 64, 114, 101, 115, 111, 108, 118, 101, 40, 115, 111, 117, 114, 99, 101, 41, 46, 64, 116, 104, 101, 110, 40, 40, 115, 111, 117, 114, 99, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 119, 101, 98, 65, 115, 115, 101, 109, 98, 108, 121, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 83, 116, 114, 101, 97, 109, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 40, 115, 111, 117, 114, 99, 101, 44, 32, 105, 109, 112, 111, 114, 116, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 106, 101, 99, 116, 32, 61, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 44, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 44, 32, 114, 101, 106, 101, 99, 116, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 106, 101, 99, 116, 40, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 110, 116, 101, 114, 115, 101, 99, 116, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 110, 116, 101, 114, 115, 101, 99, 116, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 64, 83, 101, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 115, 105, 122, 101, 32, 60, 61, 32, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 97, 100, 100, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 107, 101, 121, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 101, 121, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 104, 97, 115, 40, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 97, 100, 100, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 97, 114, 114, 97, 121, 41, 32, 124, 124, 32, 64, 105, 115, 68, 101, 114, 105, 118, 101, 100, 65, 114, 114, 97, 121, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 120, 121, 79, 98, 106, 101, 99, 116, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 115, 65, 114, 114, 97, 121, 83, 108, 111, 119, 40, 97, 114, 114, 97, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 115, 68, 105, 115, 106, 111, 105, 110, 116, 70, 114, 111, 109, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 115, 68, 105, 115, 106, 111, 105, 110, 116, 70, 114, 111, 109, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 115, 105, 122, 101, 32, 60, 61, 32, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 107, 101, 121, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 101, 121, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 104, 97, 115, 40, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 115, 111, 110, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 115, 116, 97, 116, 101, 32, 62, 32, 48, 32, 38, 38, 32, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 32, 38, 38, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 32, 38, 38, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 115, 83, 117, 98, 115, 101, 116, 79, 102, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 115, 83, 117, 98, 115, 101, 116, 79, 102, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 115, 105, 122, 101, 32, 62, 32, 115, 105, 122, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 104, 97, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 115, 83, 117, 112, 101, 114, 115, 101, 116, 79, 102, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 115, 83, 117, 112, 101, 114, 115, 101, 116, 79, 102, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 46, 64, 115, 105, 122, 101, 32, 60, 32, 115, 105, 122, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 107, 101, 121, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 101, 121, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 64, 104, 97, 115, 40, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 115, 116, 97, 116, 101, 32, 62, 32, 48, 32, 38, 38, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 89, 105, 101, 108, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 116, 97, 108, 105, 99, 115, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 105, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 60, 32, 64, 77, 111, 100, 117, 108, 101, 76, 105, 110, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 113, 117, 101, 115, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 100, 32, 121, 101, 116, 46, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 69, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 77, 111, 100, 117, 108, 101, 82, 101, 97, 100, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 82, 101, 97, 100, 121, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 65, 115, 121, 110, 99, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 115, 65, 115, 121, 110, 99, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 124, 124, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 46, 105, 115, 65, 115, 121, 110, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 115, 65, 115, 121, 110, 99, 32, 61, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 68, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 32, 124, 124, 32, 104, 97, 115, 65, 115, 121, 110, 99, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 69, 114, 114, 111, 114, 32, 61, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 117, 114, 108, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 97, 34, 44, 32, 34, 104, 114, 101, 102, 34, 44, 32, 117, 114, 108, 41, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 109, 112, 111, 114, 116, 77, 97, 112, 32, 61, 32, 64, 105, 109, 112, 111, 114, 116, 77, 97, 112, 83, 116, 97, 116, 117, 115, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 109, 112, 111, 114, 116, 77, 97, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 105, 109, 112, 111, 114, 116, 77, 97, 112, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 107, 101, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 111, 97, 100, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 65, 110, 100, 69, 118, 97, 108, 117, 97, 116, 101, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 109, 112, 111, 114, 116, 77, 97, 112, 32, 61, 32, 64, 105, 109, 112, 111, 114, 116, 77, 97, 112, 83, 116, 97, 116, 117, 115, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 109, 112, 111, 114, 116, 77, 97, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 105, 109, 112, 111, 114, 116, 77, 97, 112, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 110, 101, 119, 32, 64, 83, 101, 116, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 112, 101, 99, 105, 101, 115, 40, 108, 101, 110, 103, 116, 104, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 105, 44, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 116, 104, 105, 115, 41, 32, 33, 61, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 111, 110, 116, 101, 110, 116, 84, 121, 112, 101, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 100, 105, 102, 102, 101, 114, 101, 110, 116, 32, 99, 111, 110, 116, 101, 110, 116, 32, 116, 121, 112, 101, 32, 102, 114, 111, 109, 32, 124, 116, 104, 105, 115, 124, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 77, 97, 112, 66, 117, 99, 107, 101, 116, 44, 32, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 77, 97, 112, 66, 117, 99, 107, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 86, 97, 108, 117, 101, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 32, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 32, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 107, 101, 121, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 109, 97, 116, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 77, 97, 116, 99, 104, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 77, 97, 116, 99, 104, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 116, 99, 104, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 115, 116, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 103, 101, 120, 112, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 64, 64, 109, 97, 116, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 109, 97, 116, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 109, 97, 116, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 46, 64, 64, 109, 97, 116, 99, 104, 40, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 69, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 77, 97, 116, 99, 104, 101, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 69, 120, 112, 44, 32, 64, 82, 101, 103, 69, 120, 112, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 103, 69, 120, 112, 46, 102, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 110, 101, 119, 32, 77, 97, 116, 99, 104, 101, 114, 40, 114, 101, 103, 69, 120, 112, 44, 32, 102, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 116, 99, 104, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 103, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 117, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 40, 109, 97, 116, 99, 104, 101, 114, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 103, 108, 111, 98, 97, 108, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 116, 111, 32, 98, 101, 32, 110, 117, 108, 108, 32, 110, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 97, 114, 103, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 40, 97, 114, 103, 41, 32, 38, 38, 32, 33, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 46, 102, 108, 97, 103, 115, 41, 44, 32, 34, 103, 34, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 65, 108, 108, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 97, 32, 110, 111, 110, 45, 103, 108, 111, 98, 97, 108, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 97, 114, 103, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 109, 97, 116, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 109, 97, 116, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 97, 114, 103, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 97, 114, 103, 44, 32, 34, 103, 34, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 103, 69, 120, 112, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 103, 101, 120, 112, 46, 103, 108, 111, 98, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 117, 110, 105, 99, 111, 100, 101, 59, 10, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 120, 105, 109, 117, 109, 82, 101, 97, 115, 111, 110, 97, 98, 108, 101, 77, 97, 116, 99, 104, 83, 105, 122, 101, 32, 61, 32, 49, 48, 48, 48, 48, 48, 48, 48, 48, 59, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 105, 109, 117, 109, 82, 101, 97, 115, 111, 110, 97, 98, 108, 101, 77, 97, 116, 99, 104, 83, 105, 122, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 44, 32, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 44, 32, 98, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 97, 32, 60, 32, 98, 41, 32, 63, 32, 98, 32, 58, 32, 97, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 44, 32, 112, 111, 115, 105, 116, 105, 118, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 32, 60, 32, 112, 111, 115, 105, 116, 105, 118, 101, 41, 32, 63, 32, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 32, 58, 32, 112, 111, 115, 105, 116, 105, 118, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 105, 115, 65, 115, 121, 110, 99, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 33, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 46, 105, 115, 65, 115, 121, 110, 99, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 97, 115, 121, 110, 99, 77, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 106, 101, 99, 116, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 114, 101, 115, 111, 108, 118, 101, 58, 32, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 58, 32, 64, 114, 101, 106, 101, 99, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 111, 108, 118, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 106, 101, 99, 116, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 40, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 115, 101, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 106, 101, 99, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 115, 101, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 32, 61, 32, 114, 101, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 101, 120, 101, 99, 117, 116, 111, 114, 32, 100, 105, 100, 32, 110, 111, 116, 32, 116, 97, 107, 101, 32, 97, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 101, 120, 101, 99, 117, 116, 111, 114, 32, 100, 105, 100, 32, 110, 111, 116, 32, 116, 97, 107, 101, 32, 97, 32, 114, 101, 106, 101, 99, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 101, 121, 58, 32, 107, 101, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 58, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 97, 116, 105, 115, 102, 121, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 83, 97, 116, 105, 115, 102, 105, 101, 100, 58, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 58, 32, 91, 93, 44, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 111, 100, 117, 108, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 105, 110, 107, 69, 114, 114, 111, 114, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 58, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 100, 58, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 65, 115, 121, 110, 99, 58, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 65, 114, 114, 97, 121, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 97, 114, 114, 97, 121, 41, 32, 38, 38, 32, 64, 105, 115, 68, 101, 116, 97, 99, 104, 101, 100, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 85, 110, 100, 101, 114, 108, 121, 105, 110, 103, 32, 65, 114, 114, 97, 121, 66, 117, 102, 102, 101, 114, 32, 104, 97, 115, 32, 98, 101, 101, 110, 32, 100, 101, 116, 97, 99, 104, 101, 100, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 118, 105, 101, 119, 32, 111, 114, 32, 111, 117, 116, 45, 111, 102, 45, 98, 111, 117, 110, 100, 115, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 72, 101, 108, 112, 101, 114, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 97, 114, 114, 97, 121, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 48, 32, 63, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 32, 58, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 32, 63, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 68, 111, 110, 101, 32, 58, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 77, 97, 112, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 103, 101, 116, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 77, 97, 112, 66, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 111, 110, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 82, 101, 103, 69, 120, 112, 32, 83, 116, 114, 105, 110, 103, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 82, 101, 103, 69, 120, 112, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 83, 116, 114, 105, 110, 103, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 71, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 85, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 69, 120, 112, 44, 32, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 103, 108, 111, 98, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 109, 97, 116, 99, 104, 91, 48, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 61, 61, 32, 34, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 105, 110, 103, 44, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 109, 97, 116, 99, 104, 44, 32, 100, 111, 110, 101, 58, 32, 102, 97, 108, 115, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 101, 116, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 116, 114, 105, 110, 103, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 103, 101, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 103, 101, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 116, 101, 114, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 62, 62, 62, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 45, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 114, 115, 116, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 32, 60, 32, 48, 120, 68, 56, 48, 48, 32, 124, 124, 32, 102, 105, 114, 115, 116, 32, 62, 32, 48, 120, 68, 66, 70, 70, 32, 124, 124, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 32, 61, 61, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 99, 111, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 99, 111, 110, 100, 32, 60, 32, 48, 120, 68, 67, 48, 48, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 32, 62, 32, 48, 120, 68, 70, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 32, 43, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 64, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 108, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 107, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 107, 93, 41, 59, 10, 32, 32, 32, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 111, 102, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 108, 101, 110, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 32, 60, 32, 108, 101, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 111, 102, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 101, 100, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 111, 102, 32, 105, 110, 115, 117, 102, 102, 105, 99, 105, 101, 110, 116, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 112, 97, 100, 69, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 60, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 34, 32, 34, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 83, 108, 111, 119, 80, 97, 116, 104, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 32, 43, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 112, 97, 100, 83, 116, 97, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 60, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 34, 32, 34, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 83, 108, 111, 119, 80, 97, 116, 104, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 43, 32, 115, 116, 114, 105, 110, 103, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 83, 112, 114, 101, 97, 100, 32, 115, 121, 110, 116, 97, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 46, 46, 46, 105, 116, 101, 114, 97, 98, 108, 101, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 39, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 114, 97, 98, 108, 101, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 83, 112, 114, 101, 97, 100, 32, 115, 121, 110, 116, 97, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 46, 46, 46, 105, 116, 101, 114, 97, 98, 108, 101, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 39, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 46, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 109, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 116, 101, 109, 32, 61, 32, 110, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 116, 101, 109, 46, 100, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 105, 110, 100, 101, 120, 43, 43, 44, 32, 105, 116, 101, 109, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 69, 109, 112, 116, 121, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 69, 109, 112, 116, 121, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 115, 104, 78, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 84, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 72, 97, 110, 100, 108, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 110, 100, 108, 101, 114, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 120, 121, 32, 104, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 98, 101, 101, 110, 32, 114, 101, 118, 111, 107, 101, 100, 46, 32, 78, 111, 32, 109, 111, 114, 101, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 98, 101, 32, 112, 101, 114, 102, 111, 114, 109, 101, 100, 32, 111, 110, 32, 105, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 46, 103, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 116, 66, 121, 86, 97, 108, 87, 105, 116, 104, 84, 104, 105, 115, 40, 116, 97, 114, 103, 101, 116, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 39, 103, 101, 116, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 80, 114, 111, 120, 121, 39, 115, 32, 104, 97, 110, 100, 108, 101, 114, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 82, 101, 115, 117, 108, 116, 32, 61, 32, 116, 114, 97, 112, 46, 64, 99, 97, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 64, 116, 111, 84, 104, 105, 115, 40, 114, 101, 99, 101, 105, 118, 101, 114, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 109, 117, 115, 116, 86, 97, 108, 105, 100, 97, 116, 101, 82, 101, 115, 117, 108, 116, 79, 102, 80, 114, 111, 120, 121, 71, 101, 116, 65, 110, 100, 83, 101, 116, 84, 114, 97, 112, 115, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 97, 110, 100, 108, 101, 80, 114, 111, 120, 121, 71, 101, 116, 84, 114, 97, 112, 82, 101, 115, 117, 108, 116, 40, 116, 114, 97, 112, 82, 101, 115, 117, 108, 116, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 97, 112, 82, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 84, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 72, 97, 110, 100, 108, 101, 114, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 32, 61, 32, 64, 116, 111, 80, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 110, 100, 108, 101, 114, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 120, 121, 32, 104, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 98, 101, 101, 110, 32, 114, 101, 118, 111, 107, 101, 100, 46, 32, 78, 111, 32, 109, 111, 114, 101, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 98, 101, 32, 112, 101, 114, 102, 111, 114, 109, 101, 100, 32, 111, 110, 32, 105, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 46, 103, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 116, 66, 121, 86, 97, 108, 87, 105, 116, 104, 84, 104, 105, 115, 40, 116, 97, 114, 103, 101, 116, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 39, 103, 101, 116, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 80, 114, 111, 120, 121, 39, 115, 32, 104, 97, 110, 100, 108, 101, 114, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 82, 101, 115, 117, 108, 116, 32, 61, 32, 116, 114, 97, 112, 46, 64, 99, 97, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 64, 116, 111, 84, 104, 105, 115, 40, 114, 101, 99, 101, 105, 118, 101, 114, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 109, 117, 115, 116, 86, 97, 108, 105, 100, 97, 116, 101, 82, 101, 115, 117, 108, 116, 79, 102, 80, 114, 111, 120, 121, 71, 101, 116, 65, 110, 100, 83, 101, 116, 84, 114, 97, 112, 115, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 97, 110, 100, 108, 101, 80, 114, 111, 120, 121, 71, 101, 116, 84, 114, 97, 112, 82, 101, 115, 117, 108, 116, 40, 116, 114, 97, 112, 82, 101, 115, 117, 108, 116, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 97, 112, 82, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 84, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 72, 97, 110, 100, 108, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 110, 100, 108, 101, 114, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 120, 121, 32, 104, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 98, 101, 101, 110, 32, 114, 101, 118, 111, 107, 101, 100, 46, 32, 78, 111, 32, 109, 111, 114, 101, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 98, 101, 32, 112, 101, 114, 102, 111, 114, 109, 101, 100, 32, 111, 110, 32, 105, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 32, 105, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 39, 104, 97, 115, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 80, 114, 111, 120, 121, 39, 115, 32, 104, 97, 110, 100, 108, 101, 114, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 114, 97, 112, 46, 64, 99, 97, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 109, 117, 115, 116, 86, 97, 108, 105, 100, 97, 116, 101, 82, 101, 115, 117, 108, 116, 79, 102, 80, 114, 111, 120, 121, 84, 114, 97, 112, 115, 69, 120, 99, 101, 112, 116, 71, 101, 116, 65, 110, 100, 83, 101, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 97, 110, 100, 108, 101, 78, 101, 103, 97, 116, 105, 118, 101, 80, 114, 111, 120, 121, 72, 97, 115, 84, 114, 97, 112, 82, 101, 115, 117, 108, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 84, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 72, 97, 110, 100, 108, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 110, 100, 108, 101, 114, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 120, 121, 32, 104, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 98, 101, 101, 110, 32, 114, 101, 118, 111, 107, 101, 100, 46, 32, 78, 111, 32, 109, 111, 114, 101, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 98, 101, 32, 112, 101, 114, 102, 111, 114, 109, 101, 100, 32, 111, 110, 32, 105, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 46, 115, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 114, 97, 112, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 87, 105, 116, 104, 84, 104, 105, 115, 83, 108, 111, 112, 112, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 39, 115, 101, 116, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 80, 114, 111, 120, 121, 39, 115, 32, 104, 97, 110, 100, 108, 101, 114, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 114, 97, 112, 46, 64, 99, 97, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 116, 111, 84, 104, 105, 115, 40, 114, 101, 99, 101, 105, 118, 101, 114, 41, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 109, 117, 115, 116, 86, 97, 108, 105, 100, 97, 116, 101, 82, 101, 115, 117, 108, 116, 79, 102, 80, 114, 111, 120, 121, 71, 101, 116, 65, 110, 100, 83, 101, 116, 84, 114, 97, 112, 115, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 97, 110, 100, 108, 101, 80, 111, 115, 105, 116, 105, 118, 101, 80, 114, 111, 120, 121, 83, 101, 116, 84, 114, 97, 112, 82, 101, 115, 117, 108, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 84, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 120, 121, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 120, 121, 70, 105, 101, 108, 100, 72, 97, 110, 100, 108, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 104, 97, 110, 100, 108, 101, 114, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 120, 121, 32, 104, 97, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 98, 101, 101, 110, 32, 114, 101, 118, 111, 107, 101, 100, 46, 32, 78, 111, 32, 109, 111, 114, 101, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 98, 101, 32, 112, 101, 114, 102, 111, 114, 109, 101, 100, 32, 111, 110, 32, 105, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 97, 112, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 46, 115, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 114, 97, 112, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 87, 105, 116, 104, 84, 104, 105, 115, 83, 116, 114, 105, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 114, 97, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 39, 115, 101, 116, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 80, 114, 111, 120, 121, 39, 115, 32, 104, 97, 110, 100, 108, 101, 114, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 114, 97, 112, 46, 64, 99, 97, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 116, 111, 84, 104, 105, 115, 40, 114, 101, 99, 101, 105, 118, 101, 114, 41, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 120, 121, 32, 111, 98, 106, 101, 99, 116, 39, 115, 32, 39, 115, 101, 116, 39, 32, 116, 114, 97, 112, 32, 114, 101, 116, 117, 114, 110, 101, 100, 32, 102, 97, 108, 115, 121, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 39, 34, 32, 43, 32, 64, 83, 116, 114, 105, 110, 103, 40, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 41, 32, 43, 32, 34, 39, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 109, 117, 115, 116, 86, 97, 108, 105, 100, 97, 116, 101, 82, 101, 115, 117, 108, 116, 79, 102, 80, 114, 111, 120, 121, 71, 101, 116, 65, 110, 100, 83, 101, 116, 84, 114, 97, 112, 115, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 97, 110, 100, 108, 101, 80, 111, 115, 105, 116, 105, 118, 101, 80, 114, 111, 120, 121, 83, 101, 116, 84, 114, 97, 112, 82, 101, 115, 117, 108, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 44, 32, 105, 110, 100, 101, 120, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 118, 97, 108, 117, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 45, 45, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 32, 61, 32, 99, 111, 110, 116, 101, 120, 116, 46, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 118, 97, 108, 117, 101, 115, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 99, 111, 110, 116, 101, 120, 116, 46, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 45, 45, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 97, 114, 103, 117, 109, 101, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 106, 101, 99, 116, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 111, 110, 116, 101, 120, 116, 46, 103, 108, 111, 98, 97, 108, 67, 111, 110, 116, 101, 120, 116, 46, 112, 114, 111, 109, 105, 115, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 79, 114, 83, 116, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 104, 97, 110, 100, 108, 101, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 116, 101, 120, 116, 79, 114, 83, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 79, 114, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 40, 99, 111, 110, 116, 101, 120, 116, 79, 114, 83, 116, 97, 116, 101, 41, 32, 63, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 79, 114, 83, 116, 97, 116, 101, 41, 32, 58, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 116, 101, 120, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 41, 32, 38, 38, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 116, 104, 101, 110, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 101, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 38, 38, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 68, 101, 114, 105, 118, 101, 100, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 40, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 115, 104, 78, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 32, 38, 38, 32, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 115, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 114, 101, 106, 101, 99, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 38, 38, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 68, 101, 114, 105, 118, 101, 100, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 115, 104, 78, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 62, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 113, 117, 101, 115, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 102, 101, 116, 99, 104, 101, 100, 46, 34, 41, 59, 10, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 58, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 58, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 58, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 99, 111, 110, 116, 101, 120, 116, 58, 32, 99, 111, 110, 116, 101, 120, 116, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 58, 32, 48, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 32, 61, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 43, 43, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 105, 115, 116, 105, 110, 103, 82, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 32, 61, 32, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 115, 111, 108, 118, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 101, 109, 112, 108, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 111, 107, 101, 100, 83, 101, 103, 109, 101, 110, 116, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 101, 109, 112, 108, 97, 116, 101, 44, 32, 34, 83, 116, 114, 105, 110, 103, 46, 114, 97, 119, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 101, 109, 112, 108, 97, 116, 101, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 99, 111, 111, 107, 101, 100, 83, 101, 103, 109, 101, 110, 116, 115, 46, 114, 97, 119, 44, 32, 34, 83, 116, 114, 105, 110, 103, 46, 114, 97, 119, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 101, 109, 112, 108, 97, 116, 101, 46, 114, 97, 119, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 79, 102, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 115, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 39, 39, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 61, 32, 39, 39, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 103, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 43, 61, 32, 115, 101, 103, 109, 101, 110, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 105, 32, 43, 32, 49, 41, 32, 61, 61, 61, 32, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 60, 32, 110, 117, 109, 98, 101, 114, 79, 102, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 73, 110, 100, 101, 120, 73, 110, 65, 114, 103, 117, 109, 101, 110, 116, 115, 32, 61, 32, 105, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 73, 110, 100, 101, 120, 73, 110, 65, 114, 103, 117, 109, 101, 110, 116, 115, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 43, 61, 32, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 32, 38, 38, 32, 33, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 97, 114, 114, 97, 121, 91, 107, 43, 43, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 91, 107, 43, 43, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 91, 107, 93, 44, 32, 107, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 33, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 45, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 97, 114, 114, 97, 121, 91, 107, 45, 45, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 62, 61, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 45, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 91, 107, 45, 45, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 62, 61, 32, 48, 59, 32, 107, 45, 45, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 91, 107, 93, 44, 32, 107, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 120, 101, 99, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 101, 120, 101, 99, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 120, 101, 99, 32, 33, 61, 61, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 32, 38, 38, 32, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 101, 120, 101, 99, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 101, 120, 101, 99, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 33, 61, 61, 32, 110, 117, 108, 108, 32, 38, 38, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 104, 101, 32, 114, 101, 115, 117, 108, 116, 32, 111, 102, 32, 97, 32, 82, 101, 103, 69, 120, 112, 32, 101, 120, 101, 99, 32, 109, 117, 115, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 82, 101, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 64, 116, 114, 105, 103, 103, 101, 114, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 114, 101, 97, 115, 111, 110, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 101, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 99, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 60, 32, 48, 32, 124, 124, 32, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 101, 97, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 48, 32, 97, 110, 100, 32, 110, 111, 116, 32, 98, 101, 32, 73, 110, 102, 105, 110, 105, 116, 121, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 112, 101, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 61, 32, 40, 99, 111, 117, 110, 116, 32, 47, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 32, 124, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 32, 61, 32, 99, 111, 117, 110, 116, 32, 45, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 42, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 101, 114, 97, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 38, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 62, 62, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 101, 114, 97, 110, 100, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 105, 110, 103, 44, 32, 48, 44, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 32, 124, 124, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 42, 32, 99, 111, 117, 110, 116, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 101, 114, 97, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 38, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 62, 62, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 101, 114, 97, 110, 100, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 32, 61, 32, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 103, 108, 111, 98, 97, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 103, 108, 111, 98, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 117, 110, 105, 99, 111, 100, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 108, 111, 98, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 109, 97, 116, 99, 104, 83, 116, 114, 46, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 100, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 116, 99, 104, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 114, 101, 115, 117, 108, 116, 46, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 32, 63, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 58, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 60, 32, 48, 41, 32, 63, 32, 48, 32, 58, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 110, 32, 61, 32, 49, 59, 32, 110, 32, 60, 61, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 59, 32, 110, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 78, 32, 61, 32, 114, 101, 115, 117, 108, 116, 91, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 78, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 112, 78, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 97, 112, 78, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 99, 97, 112, 78, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 103, 114, 111, 117, 112, 115, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 32, 61, 32, 91, 32, 109, 97, 116, 99, 104, 101, 100, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 106, 32, 61, 32, 48, 59, 32, 106, 32, 60, 32, 99, 97, 112, 116, 117, 114, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 106, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 91, 106, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 86, 97, 108, 117, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 46, 64, 97, 112, 112, 108, 121, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 112, 108, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 91, 83, 121, 109, 98, 111, 108, 46, 114, 101, 112, 108, 97, 99, 101, 93, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 39, 103, 114, 111, 117, 112, 115, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 109, 97, 116, 99, 104, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 61, 32, 64, 103, 101, 116, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 40, 109, 97, 116, 99, 104, 101, 100, 44, 32, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 61, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 43, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 97, 114, 99, 104, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 32, 61, 32, 115, 101, 97, 114, 99, 104, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 83, 116, 114, 105, 110, 103, 82, 101, 112, 108, 97, 99, 101, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 112, 108, 97, 99, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 97, 114, 99, 104, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 83, 116, 114, 105, 110, 103, 83, 101, 97, 114, 99, 104, 40, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 116, 111, 32, 98, 101, 32, 110, 117, 108, 108, 32, 110, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 97, 114, 99, 104, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 41, 32, 38, 38, 32, 33, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 46, 102, 108, 97, 103, 115, 41, 44, 32, 34, 103, 34, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 97, 32, 110, 111, 110, 45, 103, 108, 111, 98, 97, 108, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 32, 61, 32, 115, 101, 97, 114, 99, 104, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 83, 116, 114, 105, 110, 103, 82, 101, 112, 108, 97, 99, 101, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 112, 108, 97, 99, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 97, 114, 99, 104, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 46, 64, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 85, 115, 105, 110, 103, 83, 116, 114, 105, 110, 103, 83, 101, 97, 114, 99, 104, 40, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 32, 61, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 33, 61, 61, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 46, 99, 97, 116, 99, 104, 40, 40, 101, 114, 114, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 32, 61, 61, 61, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 102, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 46, 116, 104, 101, 110, 40, 40, 115, 111, 117, 114, 99, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 111, 117, 114, 99, 101, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 114, 101, 102, 101, 114, 114, 101, 114, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 109, 112, 111, 114, 116, 77, 97, 112, 32, 61, 32, 64, 105, 109, 112, 111, 114, 116, 77, 97, 112, 83, 116, 97, 116, 117, 115, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 109, 112, 111, 114, 116, 77, 97, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 105, 109, 112, 111, 114, 116, 77, 97, 112, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 114, 101, 102, 101, 114, 114, 101, 114, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 110, 101, 119, 32, 64, 83, 101, 116, 41, 59, 10, 32, 32, 32, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 65, 110, 100, 69, 118, 97, 108, 117, 97, 116, 101, 77, 111, 100, 117, 108, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 103, 101, 116, 77, 111, 100, 117, 108, 101, 78, 97, 109, 101, 115, 112, 97, 99, 101, 79, 98, 106, 101, 99, 116, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 40, 97, 115, 121, 110, 99, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 119, 97, 105, 116, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 32, 61, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 112, 97, 114, 115, 101, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 32, 61, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 40, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 78, 97, 109, 101, 32, 61, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 75, 101, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 40, 100, 101, 112, 78, 97, 109, 101, 44, 32, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 69, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 100, 101, 112, 75, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 44, 32, 105, 44, 32, 100, 101, 112, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 46, 64, 115, 101, 116, 40, 100, 101, 112, 78, 97, 109, 101, 44, 32, 100, 101, 112, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 32, 61, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 83, 97, 116, 105, 115, 102, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 125, 41, 40, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 32, 61, 32, 110, 101, 119, 32, 64, 83, 101, 116, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 85, 116, 105, 108, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 44, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 41, 46, 116, 104, 101, 110, 40, 40, 101, 110, 116, 114, 121, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 46, 64, 102, 111, 114, 69, 97, 99, 104, 40, 40, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 121, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 99, 97, 99, 104, 101, 83, 97, 116, 105, 115, 102, 121, 40, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 121, 46, 105, 115, 83, 97, 116, 105, 115, 102, 105, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 44, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 59, 10, 10, 32, 32, 32, 32, 118, 105, 115, 105, 116, 101, 100, 46, 64, 97, 100, 100, 40, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 46, 116, 104, 101, 110, 40, 40, 101, 110, 116, 114, 121, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 76, 111, 97, 100, 115, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 80, 97, 114, 97, 109, 101, 116, 101, 114, 115, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 32, 61, 32, 100, 101, 112, 76, 111, 97, 100, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 69, 110, 116, 114, 121, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 105, 115, 105, 116, 101, 100, 46, 64, 104, 97, 115, 40, 100, 101, 112, 69, 110, 116, 114, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 40, 100, 101, 112, 69, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 85, 116, 105, 108, 40, 100, 101, 112, 69, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 44, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 101, 112, 76, 111, 97, 100, 115, 44, 32, 105, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 46, 105, 110, 116, 101, 114, 110, 97, 108, 65, 108, 108, 40, 100, 101, 112, 76, 111, 97, 100, 115, 41, 46, 116, 104, 101, 110, 40, 40, 100, 101, 112, 69, 110, 116, 114, 105, 101, 115, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 97, 99, 104, 101, 83, 97, 116, 105, 115, 102, 121, 65, 110, 100, 82, 101, 116, 117, 114, 110, 40, 101, 110, 116, 114, 121, 44, 32, 100, 101, 112, 69, 110, 116, 114, 105, 101, 115, 44, 32, 115, 97, 116, 105, 115, 102, 121, 105, 110, 103, 69, 110, 116, 114, 105, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 32, 61, 61, 61, 32, 112, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 97, 32, 112, 114, 111, 109, 105, 115, 101, 32, 119, 105, 116, 104, 32, 105, 116, 115, 101, 108, 102, 34, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 70, 97, 115, 116, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 104, 101, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 116, 104, 101, 110, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 101, 114, 114, 111, 114, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 97, 115, 116, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 104, 101, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 116, 104, 101, 110, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 123, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 125, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 40, 101, 114, 114, 111, 114, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 32, 124, 124, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 99, 111, 110, 116, 101, 120, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 32, 61, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 48, 32, 63, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 32, 58, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 32, 63, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 68, 111, 110, 101, 32, 58, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 32, 61, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 101, 97, 114, 99, 104, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 115, 101, 97, 114, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 115, 97, 109, 101, 86, 97, 108, 117, 101, 40, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 48, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 115, 97, 109, 101, 86, 97, 108, 117, 101, 40, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 46, 105, 110, 100, 101, 120, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 101, 97, 114, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 114, 101, 103, 101, 120, 112, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 101, 114, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 64, 64, 115, 101, 97, 114, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 97, 114, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 101, 97, 114, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 46, 64, 64, 115, 101, 97, 114, 99, 104, 40, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 101, 116, 66, 117, 99, 107, 101, 116, 44, 32, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 32, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 32, 93, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 110, 101, 119, 83, 116, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 60, 32, 110, 101, 119, 83, 116, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 61, 32, 110, 101, 119, 83, 116, 97, 116, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 109, 97, 108, 108, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 109, 97, 108, 108, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 99, 101, 105, 118, 101, 114, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 99, 101, 105, 118, 101, 114, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 99, 101, 105, 118, 101, 114, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 61, 32, 64, 115, 111, 114, 116, 67, 111, 109, 112, 97, 99, 116, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 99, 111, 109, 112, 97, 99, 116, 101, 100, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 111, 114, 116, 66, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 115, 111, 114, 116, 101, 100, 44, 32, 48, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 64, 115, 111, 114, 116, 77, 101, 114, 103, 101, 83, 111, 114, 116, 40, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 64, 115, 111, 114, 116, 67, 111, 109, 109, 105, 116, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 115, 111, 114, 116, 101, 100, 44, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 99, 101, 105, 118, 101, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 100, 101, 112, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 32, 60, 32, 51, 50, 32, 124, 124, 32, 100, 101, 112, 116, 104, 32, 62, 32, 51, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 101, 100, 32, 61, 32, 64, 115, 111, 114, 116, 77, 101, 114, 103, 101, 83, 111, 114, 116, 40, 98, 117, 99, 107, 101, 116, 44, 32, 64, 115, 111, 114, 116, 83, 116, 114, 105, 110, 103, 67, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 115, 111, 114, 116, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 115, 111, 114, 116, 101, 100, 91, 105, 93, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 115, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 68, 105, 114, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 98, 117, 99, 107, 101, 116, 115, 44, 32, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 98, 117, 99, 107, 101, 116, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 101, 110, 116, 114, 121, 46, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 100, 101, 112, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 100, 101, 112, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 66, 117, 99, 107, 101, 116, 32, 61, 32, 98, 117, 99, 107, 101, 116, 115, 91, 99, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 99, 66, 117, 99, 107, 101, 116, 44, 32, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 98, 117, 99, 107, 101, 116, 115, 44, 32, 99, 44, 32, 91, 32, 101, 110, 116, 114, 121, 32, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 98, 117, 99, 107, 101, 116, 115, 91, 105, 93, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 64, 115, 111, 114, 116, 66, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 98, 117, 99, 107, 101, 116, 115, 91, 105, 93, 44, 32, 100, 101, 112, 116, 104, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 115, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 115, 111, 114, 116, 101, 100, 44, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 115, 111, 114, 116, 101, 100, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 111, 114, 116, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 60, 61, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 114, 101, 99, 101, 105, 118, 101, 114, 41, 32, 38, 38, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 62, 61, 32, 54, 52, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 115, 111, 114, 116, 101, 100, 91, 48, 93, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 32, 123, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 112, 112, 101, 110, 100, 77, 101, 109, 99, 112, 121, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 115, 111, 114, 116, 101, 100, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 32, 61, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 32, 60, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 32, 61, 32, 115, 111, 114, 116, 101, 100, 91, 105, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 32, 60, 32, 115, 111, 114, 116, 101, 100, 76, 101, 110, 103, 116, 104, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 32, 60, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 99, 101, 105, 118, 101, 114, 44, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 114, 101, 99, 101, 105, 118, 101, 114, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 114, 101, 99, 101, 105, 118, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 114, 101, 99, 101, 105, 118, 101, 114, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 99, 111, 109, 112, 97, 99, 116, 101, 100, 44, 32, 99, 111, 109, 112, 97, 99, 116, 101, 100, 73, 110, 100, 101, 120, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 115, 83, 116, 114, 105, 110, 103, 83, 111, 114, 116, 32, 63, 32, 123, 115, 116, 114, 105, 110, 103, 58, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 44, 32, 118, 97, 108, 117, 101, 125, 32, 58, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 99, 111, 109, 112, 97, 99, 116, 101, 100, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 69, 110, 100, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 32, 61, 32, 115, 114, 99, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 69, 110, 100, 32, 61, 32, 64, 109, 105, 110, 40, 108, 101, 102, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 32, 61, 32, 108, 101, 102, 116, 69, 110, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 69, 110, 100, 32, 61, 32, 64, 109, 105, 110, 40, 114, 105, 103, 104, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 102, 116, 59, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 59, 32, 43, 43, 100, 115, 116, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 105, 103, 104, 116, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 102, 116, 32, 62, 61, 32, 108, 101, 102, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 115, 116, 44, 32, 100, 115, 116, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 105, 103, 104, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 61, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 40, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 102, 97, 108, 115, 101, 32, 124, 124, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 115, 116, 44, 32, 100, 115, 116, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 105, 103, 104, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 115, 116, 44, 32, 100, 115, 116, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 108, 101, 102, 116, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 102, 102, 101, 114, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 115, 116, 32, 61, 32, 98, 117, 102, 102, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 114, 99, 32, 61, 32, 97, 114, 114, 97, 121, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 119, 105, 100, 116, 104, 32, 61, 32, 49, 59, 32, 119, 105, 100, 116, 104, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 119, 105, 100, 116, 104, 32, 42, 61, 32, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 43, 61, 32, 50, 32, 42, 32, 119, 105, 100, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 111, 114, 116, 77, 101, 114, 103, 101, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 109, 112, 32, 61, 32, 115, 114, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 114, 99, 32, 61, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 116, 109, 112, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 114, 99, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 44, 32, 98, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 83, 116, 114, 105, 110, 103, 32, 61, 32, 97, 46, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 83, 116, 114, 105, 110, 103, 32, 61, 32, 98, 46, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 98, 83, 116, 114, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 48, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 83, 116, 114, 105, 110, 103, 32, 62, 32, 98, 83, 116, 114, 105, 110, 103, 32, 63, 32, 49, 32, 58, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 98, 106, 44, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 111, 98, 106, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 64, 115, 112, 101, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 91, 83, 121, 109, 98, 111, 108, 46, 115, 112, 101, 99, 105, 101, 115, 93, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 108, 105, 109, 105, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 115, 112, 108, 105, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 82, 101, 103, 69, 120, 112, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 82, 101, 103, 69, 120, 112, 32, 38, 38, 32, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 103, 101, 120, 112, 46, 102, 108, 97, 103, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 117, 34, 41, 32, 124, 124, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 118, 34, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 119, 70, 108, 97, 103, 115, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 121, 34, 41, 32, 63, 32, 102, 108, 97, 103, 115, 32, 58, 32, 102, 108, 97, 103, 115, 32, 43, 32, 34, 121, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 108, 105, 116, 116, 101, 114, 32, 61, 32, 110, 101, 119, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 101, 120, 112, 44, 32, 110, 101, 119, 70, 108, 97, 103, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 40, 115, 112, 108, 105, 116, 116, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 105, 109, 105, 116, 32, 61, 32, 40, 108, 105, 109, 105, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 63, 32, 48, 120, 102, 102, 102, 102, 102, 102, 102, 102, 32, 58, 32, 108, 105, 109, 105, 116, 32, 62, 62, 62, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 122, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 122, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 48, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 60, 32, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 112, 108, 105, 116, 116, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 115, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 101, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 115, 112, 108, 105, 116, 116, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 60, 61, 32, 115, 105, 122, 101, 41, 32, 63, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 58, 32, 115, 105, 122, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 61, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 117, 98, 83, 116, 114, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 115, 117, 98, 83, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 79, 102, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 109, 97, 116, 99, 104, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 49, 32, 63, 32, 109, 97, 116, 99, 104, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 32, 58, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 105, 32, 60, 61, 32, 110, 117, 109, 98, 101, 114, 79, 102, 67, 97, 112, 116, 117, 114, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 67, 97, 112, 116, 117, 114, 101, 32, 61, 32, 109, 97, 116, 99, 104, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 120, 116, 67, 97, 112, 116, 117, 114, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 83, 116, 114, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 105, 110, 103, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 115, 105, 122, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 80, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 83, 116, 114, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 108, 105, 109, 105, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 112, 108, 105, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 108, 105, 116, 116, 101, 114, 32, 61, 32, 115, 101, 112, 97, 114, 97, 116, 111, 114, 46, 64, 64, 115, 112, 108, 105, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 112, 108, 105, 116, 116, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 112, 108, 105, 116, 116, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 115, 116, 114, 105, 110, 103, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 116, 114, 105, 107, 101, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 116, 114, 105, 107, 101, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 117, 98, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 117, 98, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 117, 112, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 117, 112, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 104, 97, 115, 73, 110, 115, 116, 97, 110, 99, 101, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 116, 104, 105, 115, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 110, 115, 116, 97, 110, 99, 101, 79, 102, 40, 118, 97, 108, 117, 101, 44, 32, 116, 97, 114, 103, 101, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 121, 109, 109, 101, 116, 114, 105, 99, 68, 105, 102, 102, 101, 114, 101, 110, 99, 101, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 121, 109, 109, 101, 116, 114, 105, 99, 68, 105, 102, 102, 101, 114, 101, 110, 99, 101, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 107, 101, 121, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 115, 101, 116, 67, 108, 111, 110, 101, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 101, 121, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 64, 104, 97, 115, 40, 107, 101, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 100, 101, 108, 101, 116, 101, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 97, 100, 100, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 32, 61, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 84, 101, 115, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 101, 115, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 80, 114, 111, 109, 105, 115, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 112, 101, 114, 102, 111, 114, 109, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 40, 116, 104, 105, 115, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 32, 61, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 116, 104, 114, 111, 119, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 48, 32, 63, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 32, 58, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 32, 63, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 68, 111, 110, 101, 32, 58, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 67, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 111, 114, 65, 115, 121, 110, 99, 65, 119, 97, 105, 116, 40, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 64, 97, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 79, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 32, 43, 61, 32, 34, 44, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 32, 43, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 101, 108, 101, 109, 101, 110, 116, 46, 116, 111, 76, 111, 99, 97, 108, 101, 83, 116, 114, 105, 110, 103, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 44, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 82, 101, 118, 101, 114, 115, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 86, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 108, 101, 110, 103, 116, 104, 32, 45, 32, 107, 32, 45, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 102, 114, 111, 109, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 111, 114, 116, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 111, 114, 116, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 97, 114, 114, 97, 121, 83, 111, 114, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 115, 117, 108, 116, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 114, 116, 44, 32, 100, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 111, 83, 112, 108, 105, 99, 101, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 115, 116, 97, 114, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 62, 32, 48, 32, 63, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 58, 32, 48, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 64, 109, 105, 110, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 50, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 100, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 62, 32, 48, 32, 63, 32, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 58, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 61, 32, 64, 109, 105, 110, 40, 116, 101, 109, 112, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 44, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 119, 76, 101, 110, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 32, 45, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 119, 76, 101, 110, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 110, 101, 119, 76, 101, 110, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 97, 99, 116, 117, 97, 108, 83, 116, 97, 114, 116, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 59, 32, 105, 43, 43, 44, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 32, 43, 32, 50, 93, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 110, 101, 119, 76, 101, 110, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 107, 32, 43, 32, 97, 99, 116, 117, 97, 108, 68, 101, 108, 101, 116, 101, 67, 111, 117, 110, 116, 32, 45, 32, 105, 110, 115, 101, 114, 116, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 102, 114, 111, 109, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 97, 99, 116, 105, 111, 110, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 115, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 105, 115, 82, 101, 115, 111, 108, 118, 101, 100, 32, 63, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 58, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 104, 97, 110, 100, 108, 101, 114, 32, 63, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 99, 111, 110, 116, 101, 120, 116, 32, 58, 32, 115, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 99, 111, 117, 110, 116, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 46, 64, 111, 117, 116, 79, 102, 76, 105, 110, 101, 82, 101, 97, 99, 116, 105, 111, 110, 67, 111, 117, 110, 116, 115, 59, 32, 105, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 105, 32, 43, 61, 32, 52, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 105, 115, 82, 101, 115, 111, 108, 118, 101, 100, 32, 63, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 32, 43, 32, 49, 93, 32, 58, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 32, 43, 32, 50, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 116, 101, 120, 116, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 91, 105, 32, 43, 32, 51, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 104, 97, 110, 100, 108, 101, 114, 32, 63, 32, 99, 111, 110, 116, 101, 120, 116, 32, 58, 32, 115, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 105, 32, 61, 61, 61, 32, 99, 111, 117, 110, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 64, 115, 112, 101, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 116, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 64, 103, 101, 116, 83, 101, 116, 83, 105, 122, 101, 65, 115, 73, 110, 116, 40, 111, 116, 104, 101, 114, 41, 59, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 104, 97, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 117, 110, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 104, 97, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 107, 101, 121, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 117, 110, 105, 111, 110, 32, 101, 120, 112, 101, 99, 116, 115, 32, 111, 116, 104, 101, 114, 46, 107, 101, 121, 115, 32, 116, 111, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 107, 101, 121, 115, 46, 64, 99, 97, 108, 108, 40, 111, 116, 104, 101, 114, 44, 32, 107, 101, 121, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 58, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 115, 101, 116, 67, 108, 111, 110, 101, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 101, 121, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 64, 97, 100, 100, 40, 107, 101, 121, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 119, 105, 116, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 79, 114, 73, 110, 102, 105, 110, 105, 116, 121, 40, 105, 110, 100, 101, 120, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 32, 62, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 32, 124, 124, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 32, 105, 110, 100, 101, 120, 32, 111, 117, 116, 32, 111, 102, 32, 82, 97, 110, 103, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 61, 61, 61, 32, 97, 99, 116, 117, 97, 108, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 114, 111, 109, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 44, 32, 115, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 44, 32, 116, 97, 114, 103, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 67, 97, 108, 108, 97, 98, 108, 101, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 109, 111, 116, 101, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 97, 114, 103, 101, 116, 44, 32, 102, 114, 111, 109, 83, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 32, 63, 32, 110, 117, 108, 108, 32, 58, 32, 115, 104, 97, 100, 111, 119, 82, 101, 97, 108, 109, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 118, 97, 108, 117, 101, 32, 112, 97, 115, 115, 105, 110, 103, 32, 98, 101, 116, 119, 101, 101, 110, 32, 114, 101, 97, 108, 109, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 99, 97, 108, 108, 97, 98, 108, 101, 32, 111, 114, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 108, 101, 116, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 110, 117, 108, 108, 41, 59, 10, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 64, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 119, 114, 97, 112, 112, 101, 114, 59, 10, 125, 41, 10 };

const unsigned s_JSCCombinedCodeLength = 209150;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeLength = 183;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCode =
s_JSCCombinedCode + 0
;

const JSC::ConstructAbility s_promiseConstructorInternalPromiseConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_promiseConstructorInternalPromiseConstructorCodeConstructorKind = JSC::ConstructorKind::Naked;
const JSC::ImplementationVisibility s_promiseConstructorInternalPromiseConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorInternalPromiseConstructorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorInternalPromiseConstructorCodeLength = 685;
static const JSC::Intrinsic s_promiseConstructorInternalPromiseConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorInternalPromiseConstructorCode =
s_JSCCombinedCode + 183
;

const JSC::ConstructAbility s_promiseConstructorPromiseConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseConstructorCodeConstructorKind = JSC::ConstructorKind::Naked;
const JSC::ImplementationVisibility s_promiseConstructorPromiseConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorPromiseConstructorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorPromiseConstructorCodeLength = 678;
static const JSC::Intrinsic s_promiseConstructorPromiseConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseConstructorCode =
s_JSCCombinedCode + 868
;

const JSC::ConstructAbility s_regExpPrototypeRegExpStringIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_regExpPrototypeRegExpStringIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeRegExpStringIteratorConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeRegExpStringIteratorConstructorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeRegExpStringIteratorConstructorCodeLength = 430;
static const JSC::Intrinsic s_regExpPrototypeRegExpStringIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeRegExpStringIteratorConstructorCode =
s_JSCCombinedCode + 1546
;

const JSC::ConstructAbility s_regExpPrototypeAdvanceStringIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeAdvanceStringIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeAdvanceStringIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeAdvanceStringIndexCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeAdvanceStringIndexCodeLength = 427;
static const JSC::Intrinsic s_regExpPrototypeAdvanceStringIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeAdvanceStringIndexCode =
s_JSCCombinedCode + 1976
;

const JSC::ConstructAbility s_promiseConstructorAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorAllCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorAllCodeLength = 1749;
static const JSC::Intrinsic s_promiseConstructorAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAllCode =
s_JSCCombinedCode + 2403
;

const JSC::ConstructAbility s_promiseConstructorAllSettledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAllSettledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorAllSettledCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorAllSettledCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorAllSettledCodeLength = 2244;
static const JSC::Intrinsic s_promiseConstructorAllSettledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAllSettledCode =
s_JSCCombinedCode + 4152
;

const JSC::ConstructAbility s_stringPrototypeAnchorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeAnchorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeAnchorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeAnchorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeAnchorCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeAnchorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeAnchorCode =
s_JSCCombinedCode + 6396
;

const JSC::ConstructAbility s_promiseConstructorAnyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAnyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorAnyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorAnyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorAnyCodeLength = 1519;
static const JSC::Intrinsic s_promiseConstructorAnyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAnyCode =
s_JSCCombinedCode + 6507
;

const JSC::ConstructAbility s_functionPrototypeApplyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeApplyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeApplyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_functionPrototypeApplyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_functionPrototypeApplyCodeLength = 113;
static const JSC::Intrinsic s_functionPrototypeApplyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeApplyCode =
s_JSCCombinedCode + 8026
;

const JSC::ConstructAbility s_reflectObjectApplyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectApplyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectApplyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_reflectObjectApplyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_reflectObjectApplyCodeLength = 361;
static const JSC::Intrinsic s_reflectObjectApplyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectApplyCode =
s_JSCCombinedCode + 8139
;

const JSC::ConstructAbility s_arrayIteratorPrototypeArrayIteratorNextHelperCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayIteratorPrototypeArrayIteratorNextHelperCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayIteratorPrototypeArrayIteratorNextHelperCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayIteratorPrototypeArrayIteratorNextHelperCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayIteratorPrototypeArrayIteratorNextHelperCodeLength = 803;
static const JSC::Intrinsic s_arrayIteratorPrototypeArrayIteratorNextHelperCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayIteratorPrototypeArrayIteratorNextHelperCode =
s_JSCCombinedCode + 8500
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCodeLength = 156;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledContinueCode =
s_JSCCombinedCode + 9303
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCodeLength = 155;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnFulfilledDoneCode =
s_JSCCombinedCode + 9459
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCodeLength = 129;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorOnRejectedCode =
s_JSCCombinedCode + 9614
;

const JSC::ConstructAbility s_asyncFunctionPrototypeAsyncFunctionResumeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFunctionPrototypeAsyncFunctionResumeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFunctionPrototypeAsyncFunctionResumeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFunctionPrototypeAsyncFunctionResumeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFunctionPrototypeAsyncFunctionResumeCodeLength = 1039;
static const JSC::Intrinsic s_asyncFunctionPrototypeAsyncFunctionResumeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFunctionPrototypeAsyncFunctionResumeCode =
s_JSCCombinedCode + 9743
;

const JSC::ConstructAbility s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCodeLength = 132;
static const JSC::Intrinsic s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFunctionPrototypeAsyncFunctionResumeOnFulfilledCode =
s_JSCCombinedCode + 10782
;

const JSC::ConstructAbility s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCodeLength = 131;
static const JSC::Intrinsic s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFunctionPrototypeAsyncFunctionResumeOnRejectedCode =
s_JSCCombinedCode + 10914
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeLength = 510;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCode =
s_JSCCombinedCode + 11045
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeLength = 560;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCode =
s_JSCCombinedCode + 11555
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeLength = 787;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCode =
s_JSCCombinedCode + 12115
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeLength = 142;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCode =
s_JSCCombinedCode + 12902
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeLength = 374;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorRejectCode =
s_JSCCombinedCode + 13044
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeLength = 383;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResolveCode =
s_JSCCombinedCode + 13418
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeLength = 1779;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCode =
s_JSCCombinedCode + 13801
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCodeLength = 208;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnFulfilledCode =
s_JSCCombinedCode + 15580
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCodeLength = 199;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResumeNextOnRejectedCode =
s_JSCCombinedCode + 15788
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeLength = 247;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorYieldCode =
s_JSCCombinedCode + 15987
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCodeLength = 226;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorYieldAwaitedCode =
s_JSCCombinedCode + 16234
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCodeLength = 131;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorYieldOnRejectedCode =
s_JSCCombinedCode + 16460
;

const JSC::ConstructAbility s_moduleLoaderAsyncModuleEvaluationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderAsyncModuleEvaluationCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderAsyncModuleEvaluationCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderAsyncModuleEvaluationCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderAsyncModuleEvaluationCodeLength = 753;
static const JSC::Intrinsic s_moduleLoaderAsyncModuleEvaluationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderAsyncModuleEvaluationCode =
s_JSCCombinedCode + 16591
;

const JSC::ConstructAbility s_arrayPrototypeAtCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeAtCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeAtCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeAtCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeAtCodeLength = 323;
static const JSC::Intrinsic s_arrayPrototypeAtCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeAtCode =
s_JSCCombinedCode + 17344
;

const JSC::ConstructAbility s_stringPrototypeAtCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeAtCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeAtCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeAtCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeAtCodeLength = 403;
static const JSC::Intrinsic s_stringPrototypeAtCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeAtCode =
s_JSCCombinedCode + 17667
;

const JSC::ConstructAbility s_typedArrayPrototypeAtCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeAtCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeAtCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeAtCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeAtCodeLength = 221;
static const JSC::Intrinsic s_typedArrayPrototypeAtCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeAtCode =
s_JSCCombinedCode + 18070
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAwaitValueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAwaitValueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeAwaitValueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeAwaitValueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeAwaitValueCodeLength = 170;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAwaitValueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAwaitValueCode =
s_JSCCombinedCode + 18291
;

const JSC::ConstructAbility s_stringPrototypeBigCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBigCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeBigCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeBigCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeBigCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeBigCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBigCode =
s_JSCCombinedCode + 18461
;

const JSC::ConstructAbility s_stringPrototypeBlinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBlinkCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeBlinkCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeBlinkCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeBlinkCodeLength = 109;
static const JSC::Intrinsic s_stringPrototypeBlinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBlinkCode =
s_JSCCombinedCode + 18566
;

const JSC::ConstructAbility s_stringPrototypeBoldCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBoldCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeBoldCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeBoldCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeBoldCodeLength = 104;
static const JSC::Intrinsic s_stringPrototypeBoldCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBoldCode =
s_JSCCombinedCode + 18675
;

const JSC::ConstructAbility s_iteratorHelpersBuiltinMapIterableCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersBuiltinMapIterableCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersBuiltinMapIterableCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_iteratorHelpersBuiltinMapIterableCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_iteratorHelpersBuiltinMapIterableCodeLength = 263;
static const JSC::Intrinsic s_iteratorHelpersBuiltinMapIterableCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersBuiltinMapIterableCode =
s_JSCCombinedCode + 18779
;

const JSC::ConstructAbility s_iteratorHelpersBuiltinSetIterableCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersBuiltinSetIterableCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersBuiltinSetIterableCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_iteratorHelpersBuiltinSetIterableCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_iteratorHelpersBuiltinSetIterableCodeLength = 266;
static const JSC::Intrinsic s_iteratorHelpersBuiltinSetIterableCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersBuiltinSetIterableCode =
s_JSCCombinedCode + 19042
;

const JSC::ConstructAbility s_moduleLoaderCacheSatisfyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderCacheSatisfyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderCacheSatisfyCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_moduleLoaderCacheSatisfyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderCacheSatisfyCodeLength = 149;
static const JSC::Intrinsic s_moduleLoaderCacheSatisfyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderCacheSatisfyCode =
s_JSCCombinedCode + 19308
;

const JSC::ConstructAbility s_moduleLoaderCacheSatisfyAndReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderCacheSatisfyAndReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderCacheSatisfyAndReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_moduleLoaderCacheSatisfyAndReturnCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderCacheSatisfyAndReturnCodeLength = 410;
static const JSC::Intrinsic s_moduleLoaderCacheSatisfyAndReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderCacheSatisfyAndReturnCode =
s_JSCCombinedCode + 19457
;

const JSC::ConstructAbility s_functionPrototypeCallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeCallCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeCallCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_functionPrototypeCallCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_functionPrototypeCallCodeLength = 247;
static const JSC::Intrinsic s_functionPrototypeCallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeCallCode =
s_JSCCombinedCode + 19867
;

const JSC::ConstructAbility s_promisePrototypeCatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeCatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promisePrototypeCatchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promisePrototypeCatchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promisePrototypeCatchCodeLength = 93;
static const JSC::Intrinsic s_promisePrototypeCatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeCatchCode =
s_JSCCombinedCode + 20114
;

const JSC::ConstructAbility s_webAssemblyCompileStreamingCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_webAssemblyCompileStreamingCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_webAssemblyCompileStreamingCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_webAssemblyCompileStreamingCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_webAssemblyCompileStreamingCodeLength = 125;
static const JSC::Intrinsic s_webAssemblyCompileStreamingCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_webAssemblyCompileStreamingCode =
s_JSCCombinedCode + 20207
;

const JSC::ConstructAbility s_arrayPrototypeConcatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeConcatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeConcatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeConcatCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeConcatCodeLength = 472;
static const JSC::Intrinsic s_arrayPrototypeConcatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeConcatCode =
s_JSCCombinedCode + 20332
;

const JSC::ConstructAbility s_stringPrototypeConcatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeConcatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeConcatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeConcatCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeConcatCodeLength = 322;
static const JSC::Intrinsic s_stringPrototypeConcatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeConcatCode =
s_JSCCombinedCode + 20804
;

const JSC::ConstructAbility s_arrayPrototypeConcatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeConcatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeConcatSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeConcatSlowPathCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeConcatSlowPathCodeLength = 1556;
static const JSC::Intrinsic s_arrayPrototypeConcatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeConcatSlowPathCode =
s_JSCCombinedCode + 21126
;

const JSC::ConstructAbility s_arrayPrototypeCopyWithinCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeCopyWithinCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeCopyWithinCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeCopyWithinCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeCopyWithinCodeLength = 1367;
static const JSC::Intrinsic s_arrayPrototypeCopyWithinCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeCopyWithinCode =
s_JSCCombinedCode + 22682
;

const JSC::ConstructAbility s_injectedScriptSourceCreateArrayWithoutPrototypeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_injectedScriptSourceCreateArrayWithoutPrototypeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_injectedScriptSourceCreateArrayWithoutPrototypeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_injectedScriptSourceCreateArrayWithoutPrototypeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_injectedScriptSourceCreateArrayWithoutPrototypeCodeLength = 208;
static const JSC::Intrinsic s_injectedScriptSourceCreateArrayWithoutPrototypeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_injectedScriptSourceCreateArrayWithoutPrototypeCode =
s_JSCCombinedCode + 24049
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeLength = 244;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCode =
s_JSCCombinedCode + 24257
;

const JSC::ConstructAbility s_stringPrototypeCreateHTMLCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeCreateHTMLCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeCreateHTMLCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_stringPrototypeCreateHTMLCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeCreateHTMLCodeLength = 530;
static const JSC::Intrinsic s_stringPrototypeCreateHTMLCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeCreateHTMLCode =
s_JSCCombinedCode + 24501
;

const JSC::ConstructAbility s_injectedScriptSourceCreateInspectorInjectedScriptCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_injectedScriptSourceCreateInspectorInjectedScriptCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_injectedScriptSourceCreateInspectorInjectedScriptCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_injectedScriptSourceCreateInspectorInjectedScriptCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_injectedScriptSourceCreateInspectorInjectedScriptCodeLength = 56982;
static const JSC::Intrinsic s_injectedScriptSourceCreateInspectorInjectedScriptCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_injectedScriptSourceCreateInspectorInjectedScriptCode =
s_JSCCombinedCode + 25031
;

const JSC::ConstructAbility s_injectedScriptSourceCreateObjectWithoutPrototypeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_injectedScriptSourceCreateObjectWithoutPrototypeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_injectedScriptSourceCreateObjectWithoutPrototypeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_injectedScriptSourceCreateObjectWithoutPrototypeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_injectedScriptSourceCreateObjectWithoutPrototypeCodeLength = 371;
static const JSC::Intrinsic s_injectedScriptSourceCreateObjectWithoutPrototypeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_injectedScriptSourceCreateObjectWithoutPrototypeCode =
s_JSCCombinedCode + 82013
;

const JSC::ConstructAbility s_promiseOperationsCreateResolvingFunctionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsCreateResolvingFunctionsCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsCreateResolvingFunctionsCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsCreateResolvingFunctionsCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsCreateResolvingFunctionsCodeLength = 526;
static const JSC::Intrinsic s_promiseOperationsCreateResolvingFunctionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsCreateResolvingFunctionsCode =
s_JSCCombinedCode + 82384
;

const JSC::ConstructAbility s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeLength = 567;
static const JSC::Intrinsic s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCode =
s_JSCCombinedCode + 82910
;

const JSC::ConstructAbility s_shadowRealmPrototypeCrossRealmThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeCrossRealmThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeCrossRealmThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_shadowRealmPrototypeCrossRealmThrowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_shadowRealmPrototypeCrossRealmThrowCodeLength = 88;
static const JSC::Intrinsic s_shadowRealmPrototypeCrossRealmThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeCrossRealmThrowCode =
s_JSCCombinedCode + 83477
;

const JSC::ConstructAbility s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCodeLength = 736;
static const JSC::Intrinsic s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorDefaultAsyncFromAsyncArrayLikeCode =
s_JSCCombinedCode + 83565
;

const JSC::ConstructAbility s_arrayConstructorDefaultAsyncFromAsyncIteratorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorDefaultAsyncFromAsyncIteratorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorDefaultAsyncFromAsyncIteratorCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_arrayConstructorDefaultAsyncFromAsyncIteratorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayConstructorDefaultAsyncFromAsyncIteratorCodeLength = 682;
static const JSC::Intrinsic s_arrayConstructorDefaultAsyncFromAsyncIteratorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorDefaultAsyncFromAsyncIteratorCode =
s_JSCCombinedCode + 84301
;

const JSC::ConstructAbility s_reflectObjectDeletePropertyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectDeletePropertyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectDeletePropertyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_reflectObjectDeletePropertyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_reflectObjectDeletePropertyCodeLength = 212;
static const JSC::Intrinsic s_reflectObjectDeletePropertyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectDeletePropertyCode =
s_JSCCombinedCode + 84983
;

const JSC::ConstructAbility s_moduleLoaderDependencyKeysIfEvaluatedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderDependencyKeysIfEvaluatedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderDependencyKeysIfEvaluatedCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderDependencyKeysIfEvaluatedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderDependencyKeysIfEvaluatedCodeLength = 355;
static const JSC::Intrinsic s_moduleLoaderDependencyKeysIfEvaluatedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderDependencyKeysIfEvaluatedCode =
s_JSCCombinedCode + 85195
;

const JSC::ConstructAbility s_setPrototypeDifferenceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeDifferenceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeDifferenceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeDifferenceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeDifferenceCodeLength = 1134;
static const JSC::Intrinsic s_setPrototypeDifferenceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeDifferenceCode =
s_JSCCombinedCode + 85550
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeLength = 2350;
static const JSC::Intrinsic s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCode =
s_JSCCombinedCode + 86684
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCodeLength = 132;
static const JSC::Intrinsic s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledNormalCode =
s_JSCCombinedCode + 89034
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCodeLength = 132;
static const JSC::Intrinsic s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallOnFulfilledReturnCode =
s_JSCCombinedCode + 89166
;

const JSC::ConstructAbility s_moduleLoaderEnsureRegisteredCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderEnsureRegisteredCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderEnsureRegisteredCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderEnsureRegisteredCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderEnsureRegisteredCodeLength = 218;
static const JSC::Intrinsic s_moduleLoaderEnsureRegisteredCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderEnsureRegisteredCode =
s_JSCCombinedCode + 89298
;

const JSC::ConstructAbility s_shadowRealmPrototypeEvaluateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeEvaluateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeEvaluateCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_shadowRealmPrototypeEvaluateCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_shadowRealmPrototypeEvaluateCodeLength = 396;
static const JSC::Intrinsic s_shadowRealmPrototypeEvaluateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeEvaluateCode =
s_JSCCombinedCode + 89516
;

const JSC::ConstructAbility s_arrayPrototypeEveryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeEveryCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeEveryCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeEveryCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeEveryCodeLength = 545;
static const JSC::Intrinsic s_arrayPrototypeEveryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeEveryCode =
s_JSCCombinedCode + 89912
;

const JSC::ConstructAbility s_typedArrayPrototypeEveryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeEveryCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeEveryCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeEveryCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeEveryCodeLength = 381;
static const JSC::Intrinsic s_typedArrayPrototypeEveryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeEveryCode =
s_JSCCombinedCode + 90457
;

const JSC::ConstructAbility s_arrayPrototypeFillCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFillCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFillCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFillCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFillCodeLength = 901;
static const JSC::Intrinsic s_arrayPrototypeFillCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFillCode =
s_JSCCombinedCode + 90838
;

const JSC::ConstructAbility s_arrayPrototypeFilterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFilterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFilterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFilterCodeInlineAttribute = JSC::InlineAttribute::Always;
const int s_arrayPrototypeFilterCodeLength = 709;
static const JSC::Intrinsic s_arrayPrototypeFilterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFilterCode =
s_JSCCombinedCode + 91739
;

const JSC::ConstructAbility s_typedArrayPrototypeFilterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFilterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFilterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeFilterCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeFilterCodeLength = 979;
static const JSC::Intrinsic s_typedArrayPrototypeFilterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFilterCode =
s_JSCCombinedCode + 92448
;

const JSC::ConstructAbility s_promisePrototypeFinallyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeFinallyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promisePrototypeFinallyCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promisePrototypeFinallyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promisePrototypeFinallyCodeLength = 1051;
static const JSC::Intrinsic s_promisePrototypeFinallyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeFinallyCode =
s_JSCCombinedCode + 93427
;

const JSC::ConstructAbility s_arrayPrototypeFindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFindCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFindCodeLength = 519;
static const JSC::Intrinsic s_arrayPrototypeFindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindCode =
s_JSCCombinedCode + 94478
;

const JSC::ConstructAbility s_typedArrayPrototypeFindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeFindCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeFindCodeLength = 408;
static const JSC::Intrinsic s_typedArrayPrototypeFindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindCode =
s_JSCCombinedCode + 94997
;

const JSC::ConstructAbility s_arrayPrototypeFindIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFindIndexCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFindIndexCodeLength = 487;
static const JSC::Intrinsic s_arrayPrototypeFindIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindIndexCode =
s_JSCCombinedCode + 95405
;

const JSC::ConstructAbility s_typedArrayPrototypeFindIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeFindIndexCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeFindIndexCodeLength = 377;
static const JSC::Intrinsic s_typedArrayPrototypeFindIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindIndexCode =
s_JSCCombinedCode + 95892
;

const JSC::ConstructAbility s_arrayPrototypeFindLastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindLastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindLastCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFindLastCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFindLastCodeLength = 531;
static const JSC::Intrinsic s_arrayPrototypeFindLastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindLastCode =
s_JSCCombinedCode + 96269
;

const JSC::ConstructAbility s_typedArrayPrototypeFindLastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindLastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindLastCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeFindLastCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeFindLastCodeLength = 426;
static const JSC::Intrinsic s_typedArrayPrototypeFindLastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindLastCode =
s_JSCCombinedCode + 96800
;

const JSC::ConstructAbility s_arrayPrototypeFindLastIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindLastIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFindLastIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFindLastIndexCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFindLastIndexCodeLength = 496;
static const JSC::Intrinsic s_arrayPrototypeFindLastIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindLastIndexCode =
s_JSCCombinedCode + 97226
;

const JSC::ConstructAbility s_typedArrayPrototypeFindLastIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindLastIndexCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeFindLastIndexCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeFindLastIndexCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeFindLastIndexCodeLength = 386;
static const JSC::Intrinsic s_typedArrayPrototypeFindLastIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindLastIndexCode =
s_JSCCombinedCode + 97722
;

const JSC::ConstructAbility s_stringPrototypeFixedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFixedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeFixedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeFixedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeFixedCodeLength = 106;
static const JSC::Intrinsic s_stringPrototypeFixedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFixedCode =
s_JSCCombinedCode + 98108
;

const JSC::ConstructAbility s_arrayPrototypeFlatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFlatCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFlatCodeLength = 439;
static const JSC::Intrinsic s_arrayPrototypeFlatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatCode =
s_JSCCombinedCode + 98214
;

const JSC::ConstructAbility s_arrayPrototypeFlatIntoArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatIntoArrayCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatIntoArrayCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeFlatIntoArrayCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFlatIntoArrayCodeLength = 699;
static const JSC::Intrinsic s_arrayPrototypeFlatIntoArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatIntoArrayCode =
s_JSCCombinedCode + 98653
;

const JSC::ConstructAbility s_arrayPrototypeFlatIntoArrayWithCallbackCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatIntoArrayWithCallbackCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatIntoArrayWithCallbackCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeFlatIntoArrayWithCallbackCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFlatIntoArrayWithCallbackCodeLength = 731;
static const JSC::Intrinsic s_arrayPrototypeFlatIntoArrayWithCallbackCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatIntoArrayWithCallbackCode =
s_JSCCombinedCode + 99352
;

const JSC::ConstructAbility s_arrayPrototypeFlatMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeFlatMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeFlatMapCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeFlatMapCodeLength = 474;
static const JSC::Intrinsic s_arrayPrototypeFlatMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatMapCode =
s_JSCCombinedCode + 100083
;

const JSC::ConstructAbility s_stringPrototypeFontcolorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFontcolorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeFontcolorCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeFontcolorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeFontcolorCodeLength = 125;
static const JSC::Intrinsic s_stringPrototypeFontcolorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFontcolorCode =
s_JSCCombinedCode + 100557
;

const JSC::ConstructAbility s_stringPrototypeFontsizeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFontsizeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeFontsizeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeFontsizeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeFontsizeCodeLength = 121;
static const JSC::Intrinsic s_stringPrototypeFontsizeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFontsizeCode =
s_JSCCombinedCode + 100682
;

const JSC::ConstructAbility s_arrayPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeForEachCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeForEachCodeLength = 475;
static const JSC::Intrinsic s_arrayPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeForEachCode =
s_JSCCombinedCode + 100803
;

const JSC::ConstructAbility s_mapPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_mapPrototypeForEachCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_mapPrototypeForEachCodeLength = 539;
static const JSC::Intrinsic s_mapPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeForEachCode =
s_JSCCombinedCode + 101278
;

const JSC::ConstructAbility s_setPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeForEachCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeForEachCodeLength = 542;
static const JSC::Intrinsic s_setPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeForEachCode =
s_JSCCombinedCode + 101817
;

const JSC::ConstructAbility s_typedArrayPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeForEachCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeForEachCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeForEachCodeLength = 326;
static const JSC::Intrinsic s_typedArrayPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeForEachCode =
s_JSCCombinedCode + 102359
;

const JSC::ConstructAbility s_moduleLoaderForceFulfillPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderForceFulfillPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderForceFulfillPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_moduleLoaderForceFulfillPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderForceFulfillPromiseCodeLength = 237;
static const JSC::Intrinsic s_moduleLoaderForceFulfillPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderForceFulfillPromiseCode =
s_JSCCombinedCode + 102685
;

const JSC::ConstructAbility s_arrayConstructorFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorFromCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorFromCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayConstructorFromCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayConstructorFromCodeLength = 2093;
static const JSC::Intrinsic s_arrayConstructorFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorFromCode =
s_JSCCombinedCode + 102922
;

const JSC::ConstructAbility s_typedArrayConstructorFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorFromCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayConstructorFromCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayConstructorFromCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayConstructorFromCodeLength = 2306;
static const JSC::Intrinsic s_typedArrayConstructorFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorFromCode =
s_JSCCombinedCode + 105015
;

const JSC::ConstructAbility s_arrayConstructorFromAsyncCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorFromAsyncCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorFromAsyncCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayConstructorFromAsyncCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayConstructorFromAsyncCodeLength = 1761;
static const JSC::Intrinsic s_arrayConstructorFromAsyncCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorFromAsyncCode =
s_JSCCombinedCode + 107321
;

const JSC::ConstructAbility s_objectConstructorFromEntriesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_objectConstructorFromEntriesCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_objectConstructorFromEntriesCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_objectConstructorFromEntriesCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_objectConstructorFromEntriesCodeLength = 365;
static const JSC::Intrinsic s_objectConstructorFromEntriesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_objectConstructorFromEntriesCode =
s_JSCCombinedCode + 109082
;

const JSC::ConstructAbility s_moduleLoaderFulfillFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderFulfillFetchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderFulfillFetchCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_moduleLoaderFulfillFetchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderFulfillFetchCodeLength = 245;
static const JSC::Intrinsic s_moduleLoaderFulfillFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderFulfillFetchCode =
s_JSCCombinedCode + 109447
;

const JSC::ConstructAbility s_promiseOperationsFulfillPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsFulfillPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsFulfillPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsFulfillPromiseCodeLength = 600;
static const JSC::Intrinsic s_promiseOperationsFulfillPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillPromiseCode =
s_JSCCombinedCode + 109692
;

const JSC::ConstructAbility s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeLength = 389;
static const JSC::Intrinsic s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillPromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 110292
;

const JSC::ConstructAbility s_promiseOperationsFulfillWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsFulfillWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsFulfillWithoutPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsFulfillWithoutPromiseCodeLength = 157;
static const JSC::Intrinsic s_promiseOperationsFulfillWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillWithoutPromiseCode =
s_JSCCombinedCode + 110681
;

const JSC::ConstructAbility s_generatorPrototypeGeneratorResumeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeGeneratorResumeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeGeneratorResumeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_generatorPrototypeGeneratorResumeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_generatorPrototypeGeneratorResumeCodeLength = 930;
static const JSC::Intrinsic s_generatorPrototypeGeneratorResumeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeGeneratorResumeCode =
s_JSCCombinedCode + 110838
;

const JSC::ConstructAbility s_reflectObjectGetCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectGetCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectGetCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_reflectObjectGetCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_reflectObjectGetCodeLength = 328;
static const JSC::Intrinsic s_reflectObjectGetCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectGetCode =
s_JSCCombinedCode + 111768
;

const JSC::ConstructAbility s_setPrototypeGetSetSizeAsIntCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeGetSetSizeAsIntCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeGetSetSizeAsIntCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_setPrototypeGetSetSizeAsIntCodeInlineAttribute = JSC::InlineAttribute::Always;
const int s_setPrototypeGetSetSizeAsIntCodeLength = 485;
static const JSC::Intrinsic s_setPrototypeGetSetSizeAsIntCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeGetSetSizeAsIntCode =
s_JSCCombinedCode + 112096
;

const JSC::ConstructAbility s_regExpPrototypeGetSubstitutionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeGetSubstitutionCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeGetSubstitutionCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeGetSubstitutionCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeGetSubstitutionCodeLength = 3603;
static const JSC::Intrinsic s_regExpPrototypeGetSubstitutionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeGetSubstitutionCode =
s_JSCCombinedCode + 112581
;

const JSC::ConstructAbility s_mapConstructorGroupByCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapConstructorGroupByCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapConstructorGroupByCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_mapConstructorGroupByCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_mapConstructorGroupByCodeLength = 645;
static const JSC::Intrinsic s_mapConstructorGroupByCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapConstructorGroupByCode =
s_JSCCombinedCode + 116184
;

const JSC::ConstructAbility s_objectConstructorGroupByCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_objectConstructorGroupByCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_objectConstructorGroupByCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_objectConstructorGroupByCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_objectConstructorGroupByCodeLength = 687;
static const JSC::Intrinsic s_objectConstructorGroupByCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_objectConstructorGroupByCode =
s_JSCCombinedCode + 116829
;

const JSC::ConstructAbility s_reflectObjectHasCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectHasCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_reflectObjectHasCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_reflectObjectHasCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_reflectObjectHasCodeLength = 200;
static const JSC::Intrinsic s_reflectObjectHasCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectHasCode =
s_JSCCombinedCode + 117516
;

const JSC::ConstructAbility s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeLength = 674;
static const JSC::Intrinsic s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCode =
s_JSCCombinedCode + 117716
;

const JSC::ConstructAbility s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeLength = 1515;
static const JSC::Intrinsic s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCode =
s_JSCCombinedCode + 118390
;

const JSC::ConstructAbility s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeLength = 756;
static const JSC::Intrinsic s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeHasObservableSideEffectsForStringReplaceCode =
s_JSCCombinedCode + 119905
;

const JSC::ConstructAbility s_shadowRealmPrototypeImportValueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeImportValueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeImportValueCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_shadowRealmPrototypeImportValueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_shadowRealmPrototypeImportValueCodeLength = 761;
static const JSC::Intrinsic s_shadowRealmPrototypeImportValueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeImportValueCode =
s_JSCCombinedCode + 120661
;

const JSC::ConstructAbility s_arrayPrototypeIncludesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeIncludesCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeIncludesCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeIncludesCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeIncludesCodeLength = 808;
static const JSC::Intrinsic s_arrayPrototypeIncludesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeIncludesCode =
s_JSCCombinedCode + 121422
;

const JSC::ConstructAbility s_webAssemblyInstantiateStreamingCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_webAssemblyInstantiateStreamingCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_webAssemblyInstantiateStreamingCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_webAssemblyInstantiateStreamingCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_webAssemblyInstantiateStreamingCodeLength = 224;
static const JSC::Intrinsic s_webAssemblyInstantiateStreamingCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_webAssemblyInstantiateStreamingCode =
s_JSCCombinedCode + 122230
;

const JSC::ConstructAbility s_internalPromiseConstructorInternalAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_internalPromiseConstructorInternalAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_internalPromiseConstructorInternalAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_internalPromiseConstructorInternalAllCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_internalPromiseConstructorInternalAllCodeLength = 1450;
static const JSC::Intrinsic s_internalPromiseConstructorInternalAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_internalPromiseConstructorInternalAllCode =
s_JSCCombinedCode + 122454
;

const JSC::ConstructAbility s_setPrototypeIntersectionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeIntersectionCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeIntersectionCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeIntersectionCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeIntersectionCodeLength = 1131;
static const JSC::Intrinsic s_setPrototypeIntersectionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeIntersectionCode =
s_JSCCombinedCode + 123904
;

const JSC::ConstructAbility s_arrayConstructorIsArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorIsArrayCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorIsArrayCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayConstructorIsArrayCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayConstructorIsArrayCodeLength = 202;
static const JSC::Intrinsic s_arrayConstructorIsArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorIsArrayCode =
s_JSCCombinedCode + 125035
;

const JSC::ConstructAbility s_setPrototypeIsDisjointFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeIsDisjointFromCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeIsDisjointFromCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeIsDisjointFromCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeIsDisjointFromCodeLength = 1096;
static const JSC::Intrinsic s_setPrototypeIsDisjointFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeIsDisjointFromCode =
s_JSCCombinedCode + 125237
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeIsExecutionStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeIsExecutionStateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeIsExecutionStateCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeIsExecutionStateCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeIsExecutionStateCodeLength = 402;
static const JSC::Intrinsic s_asyncGeneratorPrototypeIsExecutionStateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeIsExecutionStateCode =
s_JSCCombinedCode + 126333
;

const JSC::ConstructAbility s_globalObjectIsFiniteCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalObjectIsFiniteCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalObjectIsFiniteCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_globalObjectIsFiniteCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_globalObjectIsFiniteCodeLength = 216;
static const JSC::Intrinsic s_globalObjectIsFiniteCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalObjectIsFiniteCode =
s_JSCCombinedCode + 126735
;

const JSC::ConstructAbility s_numberConstructorIsFiniteCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_numberConstructorIsFiniteCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_numberConstructorIsFiniteCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_numberConstructorIsFiniteCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_numberConstructorIsFiniteCodeLength = 211;
static const JSC::Intrinsic s_numberConstructorIsFiniteCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_numberConstructorIsFiniteCode =
s_JSCCombinedCode + 126951
;

const JSC::ConstructAbility s_setPrototypeIsSubsetOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeIsSubsetOfCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeIsSubsetOfCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeIsSubsetOfCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeIsSubsetOfCodeLength = 806;
static const JSC::Intrinsic s_setPrototypeIsSubsetOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeIsSubsetOfCode =
s_JSCCombinedCode + 127162
;

const JSC::ConstructAbility s_setPrototypeIsSupersetOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeIsSupersetOfCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeIsSupersetOfCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeIsSupersetOfCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeIsSupersetOfCodeLength = 751;
static const JSC::Intrinsic s_setPrototypeIsSupersetOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeIsSupersetOfCode =
s_JSCCombinedCode + 127968
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeIsSuspendYieldStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeIsSuspendYieldStateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeIsSuspendYieldStateCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_asyncGeneratorPrototypeIsSuspendYieldStateCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeIsSuspendYieldStateCodeLength = 327;
static const JSC::Intrinsic s_asyncGeneratorPrototypeIsSuspendYieldStateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeIsSuspendYieldStateCode =
s_JSCCombinedCode + 128719
;

const JSC::ConstructAbility s_stringPrototypeItalicsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeItalicsCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeItalicsCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeItalicsCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeItalicsCodeLength = 107;
static const JSC::Intrinsic s_stringPrototypeItalicsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeItalicsCode =
s_JSCCombinedCode + 129046
;

const JSC::ConstructAbility s_moduleLoaderLinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLinkCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLinkCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderLinkCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderLinkCodeLength = 905;
static const JSC::Intrinsic s_moduleLoaderLinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLinkCode =
s_JSCCombinedCode + 129153
;

const JSC::ConstructAbility s_stringPrototypeLinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeLinkCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeLinkCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeLinkCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeLinkCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeLinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeLinkCode =
s_JSCCombinedCode + 130058
;

const JSC::ConstructAbility s_moduleLoaderLinkAndEvaluateModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLinkAndEvaluateModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLinkAndEvaluateModuleCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderLinkAndEvaluateModuleCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderLinkAndEvaluateModuleCodeLength = 174;
static const JSC::Intrinsic s_moduleLoaderLinkAndEvaluateModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLinkAndEvaluateModuleCode =
s_JSCCombinedCode + 130169
;

const JSC::ConstructAbility s_moduleLoaderLoadAndEvaluateModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLoadAndEvaluateModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLoadAndEvaluateModuleCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderLoadAndEvaluateModuleCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderLoadAndEvaluateModuleCodeLength = 337;
static const JSC::Intrinsic s_moduleLoaderLoadAndEvaluateModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLoadAndEvaluateModuleCode =
s_JSCCombinedCode + 130343
;

const JSC::ConstructAbility s_moduleLoaderLoadModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLoadModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderLoadModuleCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderLoadModuleCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderLoadModuleCodeLength = 275;
static const JSC::Intrinsic s_moduleLoaderLoadModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLoadModuleCode =
s_JSCCombinedCode + 130680
;

const JSC::ConstructAbility s_arrayPrototypeMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeMapCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeMapCodeLength = 624;
static const JSC::Intrinsic s_arrayPrototypeMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMapCode =
s_JSCCombinedCode + 130955
;

const JSC::ConstructAbility s_typedArrayPrototypeMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeMapCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeMapCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeMapCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeMapCodeLength = 843;
static const JSC::Intrinsic s_typedArrayPrototypeMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeMapCode =
s_JSCCombinedCode + 131579
;

const JSC::ConstructAbility s_mapIteratorPrototypeMapIteratorNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapIteratorPrototypeMapIteratorNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapIteratorPrototypeMapIteratorNextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_mapIteratorPrototypeMapIteratorNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_mapIteratorPrototypeMapIteratorNextCodeLength = 505;
static const JSC::Intrinsic s_mapIteratorPrototypeMapIteratorNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapIteratorPrototypeMapIteratorNextCode =
s_JSCCombinedCode + 132422
;

const JSC::ConstructAbility s_regExpPrototypeMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeMatchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpPrototypeMatchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeMatchCodeLength = 338;
static const JSC::Intrinsic s_regExpPrototypeMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchCode =
s_JSCCombinedCode + 132927
;

const JSC::ConstructAbility s_stringPrototypeMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeMatchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeMatchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeMatchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeMatchCodeLength = 492;
static const JSC::Intrinsic s_stringPrototypeMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeMatchCode =
s_JSCCombinedCode + 133265
;

const JSC::ConstructAbility s_regExpPrototypeMatchAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeMatchAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpPrototypeMatchAllCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeMatchAllCodeLength = 619;
static const JSC::Intrinsic s_regExpPrototypeMatchAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchAllCode =
s_JSCCombinedCode + 133757
;

const JSC::ConstructAbility s_stringPrototypeMatchAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeMatchAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeMatchAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeMatchAllCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeMatchAllCodeLength = 657;
static const JSC::Intrinsic s_stringPrototypeMatchAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeMatchAllCode =
s_JSCCombinedCode + 134376
;

const JSC::ConstructAbility s_regExpPrototypeMatchSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeMatchSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeMatchSlowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeMatchSlowCodeLength = 812;
static const JSC::Intrinsic s_regExpPrototypeMatchSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchSlowCode =
s_JSCCombinedCode + 135033
;

const JSC::ConstructAbility s_arrayPrototypeMaxWithPositivesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMaxWithPositivesCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeMaxWithPositivesCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeMaxWithPositivesCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeMaxWithPositivesCodeLength = 69;
static const JSC::Intrinsic s_arrayPrototypeMaxWithPositivesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMaxWithPositivesCode =
s_JSCCombinedCode + 135845
;

const JSC::ConstructAbility s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeLength = 138;
static const JSC::Intrinsic s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMinWithMaybeNegativeZeroAndPositiveCode =
s_JSCCombinedCode + 135914
;

const JSC::ConstructAbility s_moduleLoaderModuleEvaluationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderModuleEvaluationCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderModuleEvaluationCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderModuleEvaluationCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderModuleEvaluationCodeLength = 585;
static const JSC::Intrinsic s_moduleLoaderModuleEvaluationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderModuleEvaluationCode =
s_JSCCombinedCode + 136052
;

const JSC::ConstructAbility s_promiseOperationsNewHandledRejectedPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewHandledRejectedPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsNewHandledRejectedPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsNewHandledRejectedPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsNewHandledRejectedPromiseCodeLength = 304;
static const JSC::Intrinsic s_promiseOperationsNewHandledRejectedPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewHandledRejectedPromiseCode =
s_JSCCombinedCode + 136637
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseCapabilityCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseCapabilityCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsNewPromiseCapabilityCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsNewPromiseCapabilityCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsNewPromiseCapabilityCodeLength = 572;
static const JSC::Intrinsic s_promiseOperationsNewPromiseCapabilityCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseCapabilityCode =
s_JSCCombinedCode + 136941
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseCapabilitySlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseCapabilitySlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsNewPromiseCapabilitySlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsNewPromiseCapabilitySlowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsNewPromiseCapabilitySlowCodeLength = 869;
static const JSC::Intrinsic s_promiseOperationsNewPromiseCapabilitySlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseCapabilitySlowCode =
s_JSCCombinedCode + 137513
;

const JSC::ConstructAbility s_moduleLoaderNewRegistryEntryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderNewRegistryEntryCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderNewRegistryEntryCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_moduleLoaderNewRegistryEntryCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderNewRegistryEntryCodeLength = 694;
static const JSC::Intrinsic s_moduleLoaderNewRegistryEntryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderNewRegistryEntryCode =
s_JSCCombinedCode + 138382
;

const JSC::ConstructAbility s_arrayIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayIteratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayIteratorPrototypeNextCodeLength = 566;
static const JSC::Intrinsic s_arrayIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayIteratorPrototypeNextCode =
s_JSCCombinedCode + 139076
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeNextCodeLength = 935;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeNextCode =
s_JSCCombinedCode + 139642
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncGeneratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeNextCodeLength = 118;
static const JSC::Intrinsic s_asyncGeneratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeNextCode =
s_JSCCombinedCode + 140577
;

const JSC::ConstructAbility s_generatorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_generatorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_generatorPrototypeNextCodeLength = 441;
static const JSC::Intrinsic s_generatorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeNextCode =
s_JSCCombinedCode + 140695
;

const JSC::ConstructAbility s_mapIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_mapIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_mapIteratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_mapIteratorPrototypeNextCodeLength = 384;
static const JSC::Intrinsic s_mapIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapIteratorPrototypeNextCode =
s_JSCCombinedCode + 141136
;

const JSC::ConstructAbility s_regExpStringIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpStringIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpStringIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpStringIteratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpStringIteratorPrototypeNextCodeLength = 1328;
static const JSC::Intrinsic s_regExpStringIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpStringIteratorPrototypeNextCode =
s_JSCCombinedCode + 141520
;

const JSC::ConstructAbility s_setIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setIteratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setIteratorPrototypeNextCodeLength = 383;
static const JSC::Intrinsic s_setIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setIteratorPrototypeNextCode =
s_JSCCombinedCode + 142848
;

const JSC::ConstructAbility s_stringIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringIteratorPrototypeNextCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringIteratorPrototypeNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringIteratorPrototypeNextCodeLength = 1247;
static const JSC::Intrinsic s_stringIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringIteratorPrototypeNextCode =
s_JSCCombinedCode + 143231
;

const JSC::ConstructAbility s_arrayConstructorOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorOfCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayConstructorOfCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayConstructorOfCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayConstructorOfCodeLength = 307;
static const JSC::Intrinsic s_arrayConstructorOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorOfCode =
s_JSCCombinedCode + 144478
;

const JSC::ConstructAbility s_typedArrayConstructorOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorOfCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayConstructorOfCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayConstructorOfCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayConstructorOfCodeLength = 430;
static const JSC::Intrinsic s_typedArrayConstructorOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorOfCode =
s_JSCCombinedCode + 144785
;

const JSC::ConstructAbility s_stringPrototypePadEndCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypePadEndCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypePadEndCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypePadEndCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypePadEndCodeLength = 953;
static const JSC::Intrinsic s_stringPrototypePadEndCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypePadEndCode =
s_JSCCombinedCode + 145215
;

const JSC::ConstructAbility s_stringPrototypePadStartCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypePadStartCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypePadStartCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypePadStartCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypePadStartCodeLength = 955;
static const JSC::Intrinsic s_stringPrototypePadStartCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypePadStartCode =
s_JSCCombinedCode + 146168
;

const JSC::ConstructAbility s_iteratorHelpersPerformIterationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersPerformIterationCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersPerformIterationCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_iteratorHelpersPerformIterationCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_iteratorHelpersPerformIterationCodeLength = 785;
static const JSC::Intrinsic s_iteratorHelpersPerformIterationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersPerformIterationCode =
s_JSCCombinedCode + 147123
;

const JSC::ConstructAbility s_promiseOperationsPerformPromiseThenCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPerformPromiseThenCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPerformPromiseThenCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPerformPromiseThenCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPerformPromiseThenCodeLength = 1169;
static const JSC::Intrinsic s_promiseOperationsPerformPromiseThenCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPerformPromiseThenCode =
s_JSCCombinedCode + 147908
;

const JSC::ConstructAbility s_proxyHelpersPerformProxyObjectGetCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_proxyHelpersPerformProxyObjectGetCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_proxyHelpersPerformProxyObjectGetCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_proxyHelpersPerformProxyObjectGetCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_proxyHelpersPerformProxyObjectGetCodeLength = 810;
static const JSC::Intrinsic s_proxyHelpersPerformProxyObjectGetCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_proxyHelpersPerformProxyObjectGetCode =
s_JSCCombinedCode + 149077
;

const JSC::ConstructAbility s_proxyHelpersPerformProxyObjectGetByValCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_proxyHelpersPerformProxyObjectGetByValCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_proxyHelpersPerformProxyObjectGetByValCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_proxyHelpersPerformProxyObjectGetByValCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_proxyHelpersPerformProxyObjectGetByValCodeLength = 863;
static const JSC::Intrinsic s_proxyHelpersPerformProxyObjectGetByValCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_proxyHelpersPerformProxyObjectGetByValCode =
s_JSCCombinedCode + 149887
;

const JSC::ConstructAbility s_proxyHelpersPerformProxyObjectHasCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_proxyHelpersPerformProxyObjectHasCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_proxyHelpersPerformProxyObjectHasCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_proxyHelpersPerformProxyObjectHasCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_proxyHelpersPerformProxyObjectHasCodeLength = 759;
static const JSC::Intrinsic s_proxyHelpersPerformProxyObjectHasCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_proxyHelpersPerformProxyObjectHasCode =
s_JSCCombinedCode + 150750
;

const JSC::ConstructAbility s_proxyHelpersPerformProxyObjectSetSloppyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_proxyHelpersPerformProxyObjectSetSloppyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_proxyHelpersPerformProxyObjectSetSloppyCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_proxyHelpersPerformProxyObjectSetSloppyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_proxyHelpersPerformProxyObjectSetSloppyCodeLength = 837;
static const JSC::Intrinsic s_proxyHelpersPerformProxyObjectSetSloppyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_proxyHelpersPerformProxyObjectSetSloppyCode =
s_JSCCombinedCode + 151509
;

const JSC::ConstructAbility s_proxyHelpersPerformProxyObjectSetStrictCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_proxyHelpersPerformProxyObjectSetStrictCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_proxyHelpersPerformProxyObjectSetStrictCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_proxyHelpersPerformProxyObjectSetStrictCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_proxyHelpersPerformProxyObjectSetStrictCodeLength = 941;
static const JSC::Intrinsic s_proxyHelpersPerformProxyObjectSetStrictCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_proxyHelpersPerformProxyObjectSetStrictCode =
s_JSCCombinedCode + 152346
;

const JSC::ConstructAbility s_promiseConstructorPromiseAllNewResolveElementCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseAllNewResolveElementCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorPromiseAllNewResolveElementCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseConstructorPromiseAllNewResolveElementCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorPromiseAllNewResolveElementCodeLength = 460;
static const JSC::Intrinsic s_promiseConstructorPromiseAllNewResolveElementCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseAllNewResolveElementCode =
s_JSCCombinedCode + 153287
;

const JSC::ConstructAbility s_promiseConstructorPromiseAllOnFulfilledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseAllOnFulfilledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorPromiseAllOnFulfilledCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseConstructorPromiseAllOnFulfilledCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorPromiseAllOnFulfilledCodeLength = 343;
static const JSC::Intrinsic s_promiseConstructorPromiseAllOnFulfilledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseAllOnFulfilledCode =
s_JSCCombinedCode + 153747
;

const JSC::ConstructAbility s_promiseConstructorPromiseAllSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseAllSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorPromiseAllSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseConstructorPromiseAllSlowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorPromiseAllSlowCodeLength = 1524;
static const JSC::Intrinsic s_promiseConstructorPromiseAllSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseAllSlowCode =
s_JSCCombinedCode + 154090
;

const JSC::ConstructAbility s_promiseOperationsPromiseEmptyOnFulfilledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseEmptyOnFulfilledCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseEmptyOnFulfilledCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseEmptyOnFulfilledCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseEmptyOnFulfilledCodeLength = 66;
static const JSC::Intrinsic s_promiseOperationsPromiseEmptyOnFulfilledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseEmptyOnFulfilledCode =
s_JSCCombinedCode + 155614
;

const JSC::ConstructAbility s_promiseOperationsPromiseEmptyOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseEmptyOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseEmptyOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseEmptyOnRejectedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseEmptyOnRejectedCodeLength = 65;
static const JSC::Intrinsic s_promiseOperationsPromiseEmptyOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseEmptyOnRejectedCode =
s_JSCCombinedCode + 155680
;

const JSC::ConstructAbility s_promiseConstructorPromiseNewOnRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseNewOnRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorPromiseNewOnRejectedCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseConstructorPromiseNewOnRejectedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorPromiseNewOnRejectedCodeLength = 172;
static const JSC::Intrinsic s_promiseConstructorPromiseNewOnRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseNewOnRejectedCode =
s_JSCCombinedCode + 155745
;

const JSC::ConstructAbility s_promiseConstructorPromiseOnRejectedWithContextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseOnRejectedWithContextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorPromiseOnRejectedWithContextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseConstructorPromiseOnRejectedWithContextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorPromiseOnRejectedWithContextCodeLength = 157;
static const JSC::Intrinsic s_promiseConstructorPromiseOnRejectedWithContextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseOnRejectedWithContextCode =
s_JSCCombinedCode + 155917
;

const JSC::ConstructAbility s_promiseOperationsPromiseReactionJobCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseReactionJobCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseReactionJobCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseReactionJobCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseReactionJobCodeLength = 1206;
static const JSC::Intrinsic s_promiseOperationsPromiseReactionJobCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseReactionJobCode =
s_JSCCombinedCode + 156074
;

const JSC::ConstructAbility s_promiseOperationsPromiseReactionJobWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseReactionJobWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseReactionJobWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseReactionJobWithoutPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseReactionJobWithoutPromiseCodeLength = 209;
static const JSC::Intrinsic s_promiseOperationsPromiseReactionJobWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseReactionJobWithoutPromiseCode =
s_JSCCombinedCode + 157280
;

const JSC::ConstructAbility s_promiseOperationsPromiseRejectSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseRejectSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseRejectSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseRejectSlowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseRejectSlowCodeLength = 257;
static const JSC::Intrinsic s_promiseOperationsPromiseRejectSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseRejectSlowCode =
s_JSCCombinedCode + 157489
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseResolveCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseResolveCodeLength = 374;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveCode =
s_JSCCombinedCode + 157746
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveSlowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveSlowCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseResolveSlowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseResolveSlowCodeLength = 256;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveSlowCode =
s_JSCCombinedCode + 158120
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseResolveThenableJobCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseResolveThenableJobCodeLength = 268;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobCode =
s_JSCCombinedCode + 158376
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobFastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobFastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobFastCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseResolveThenableJobFastCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseResolveThenableJobFastCodeLength = 1206;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobFastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobFastCode =
s_JSCCombinedCode + 158644
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeLength = 428;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobWithDerivedPromiseCode =
s_JSCCombinedCode + 159850
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeLength = 1327;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCode =
s_JSCCombinedCode + 160278
;

const JSC::ConstructAbility s_moduleLoaderProvideFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderProvideFetchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderProvideFetchCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderProvideFetchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderProvideFetchCodeLength = 226;
static const JSC::Intrinsic s_moduleLoaderProvideFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderProvideFetchCode =
s_JSCCombinedCode + 161605
;

const JSC::ConstructAbility s_promiseOperationsPushNewPromiseReactionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPushNewPromiseReactionCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsPushNewPromiseReactionCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsPushNewPromiseReactionCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsPushNewPromiseReactionCodeLength = 1021;
static const JSC::Intrinsic s_promiseOperationsPushNewPromiseReactionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPushNewPromiseReactionCode =
s_JSCCombinedCode + 161831
;

const JSC::ConstructAbility s_promiseConstructorRaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorRaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorRaceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorRaceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorRaceCodeLength = 666;
static const JSC::Intrinsic s_promiseConstructorRaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorRaceCode =
s_JSCCombinedCode + 162852
;

const JSC::ConstructAbility s_stringConstructorRawCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringConstructorRawCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringConstructorRawCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringConstructorRawCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringConstructorRawCodeLength = 860;
static const JSC::Intrinsic s_stringConstructorRawCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringConstructorRawCode =
s_JSCCombinedCode + 163518
;

const JSC::ConstructAbility s_arrayPrototypeReduceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeReduceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeReduceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeReduceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeReduceCodeLength = 954;
static const JSC::Intrinsic s_arrayPrototypeReduceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeReduceCode =
s_JSCCombinedCode + 164378
;

const JSC::ConstructAbility s_typedArrayPrototypeReduceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeReduceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeReduceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeReduceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeReduceCodeLength = 660;
static const JSC::Intrinsic s_typedArrayPrototypeReduceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeReduceCode =
s_JSCCombinedCode + 165332
;

const JSC::ConstructAbility s_arrayPrototypeReduceRightCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeReduceRightCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeReduceRightCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeReduceRightCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeReduceRightCodeLength = 969;
static const JSC::Intrinsic s_arrayPrototypeReduceRightCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeReduceRightCode =
s_JSCCombinedCode + 165992
;

const JSC::ConstructAbility s_typedArrayPrototypeReduceRightCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeReduceRightCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeReduceRightCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeReduceRightCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeReduceRightCodeLength = 675;
static const JSC::Intrinsic s_typedArrayPrototypeReduceRightCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeReduceRightCode =
s_JSCCombinedCode + 166961
;

const JSC::ConstructAbility s_regExpPrototypeRegExpExecCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeRegExpExecCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeRegExpExecCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_regExpPrototypeRegExpExecCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeRegExpExecCodeLength = 426;
static const JSC::Intrinsic s_regExpPrototypeRegExpExecCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeRegExpExecCode =
s_JSCCombinedCode + 167636
;

const JSC::ConstructAbility s_promiseConstructorRejectCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorRejectCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorRejectCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorRejectCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorRejectCodeLength = 340;
static const JSC::Intrinsic s_promiseConstructorRejectCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorRejectCode =
s_JSCCombinedCode + 168062
;

const JSC::ConstructAbility s_promiseOperationsRejectPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsRejectPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsRejectPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsRejectPromiseCodeLength = 717;
static const JSC::Intrinsic s_promiseOperationsRejectPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectPromiseCode =
s_JSCCombinedCode + 168402
;

const JSC::ConstructAbility s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeLength = 390;
static const JSC::Intrinsic s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 169119
;

const JSC::ConstructAbility s_promiseOperationsRejectWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsRejectWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsRejectWithoutPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsRejectWithoutPromiseCodeLength = 158;
static const JSC::Intrinsic s_promiseOperationsRejectWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectWithoutPromiseCode =
s_JSCCombinedCode + 169509
;

const JSC::ConstructAbility s_stringPrototypeRepeatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeRepeatCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeRepeatCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeRepeatCodeLength = 532;
static const JSC::Intrinsic s_stringPrototypeRepeatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatCode =
s_JSCCombinedCode + 169667
;

const JSC::ConstructAbility s_stringPrototypeRepeatCharactersSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatCharactersSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeRepeatCharactersSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_stringPrototypeRepeatCharactersSlowPathCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeRepeatCharactersSlowPathCodeLength = 535;
static const JSC::Intrinsic s_stringPrototypeRepeatCharactersSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatCharactersSlowPathCode =
s_JSCCombinedCode + 170199
;

const JSC::ConstructAbility s_stringPrototypeRepeatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeRepeatSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_stringPrototypeRepeatSlowPathCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeRepeatSlowPathCodeLength = 496;
static const JSC::Intrinsic s_stringPrototypeRepeatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatSlowPathCode =
s_JSCCombinedCode + 170734
;

const JSC::ConstructAbility s_regExpPrototypeReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeReplaceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpPrototypeReplaceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeReplaceCodeLength = 3216;
static const JSC::Intrinsic s_regExpPrototypeReplaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeReplaceCode =
s_JSCCombinedCode + 171230
;

const JSC::ConstructAbility s_stringPrototypeReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeReplaceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeReplaceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeReplaceCodeLength = 693;
static const JSC::Intrinsic s_stringPrototypeReplaceCodeIntrinsic = JSC::StringPrototypeReplaceIntrinsic;
const char* const s_stringPrototypeReplaceCode =
s_JSCCombinedCode + 174446
;

const JSC::ConstructAbility s_stringPrototypeReplaceAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeReplaceAllCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeReplaceAllCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeReplaceAllCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeReplaceAllCodeLength = 907;
static const JSC::Intrinsic s_stringPrototypeReplaceAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeReplaceAllCode =
s_JSCCombinedCode + 175139
;

const JSC::ConstructAbility s_moduleLoaderRequestFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestFetchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestFetchCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderRequestFetchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderRequestFetchCodeLength = 779;
static const JSC::Intrinsic s_moduleLoaderRequestFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestFetchCode =
s_JSCCombinedCode + 176046
;

const JSC::ConstructAbility s_moduleLoaderRequestImportModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestImportModuleCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestImportModuleCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderRequestImportModuleCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderRequestImportModuleCodeLength = 443;
static const JSC::Intrinsic s_moduleLoaderRequestImportModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestImportModuleCode =
s_JSCCombinedCode + 176825
;

const JSC::ConstructAbility s_moduleLoaderRequestInstantiateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestInstantiateCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestInstantiateCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderRequestInstantiateCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderRequestInstantiateCodeLength = 1260;
static const JSC::Intrinsic s_moduleLoaderRequestInstantiateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestInstantiateCode =
s_JSCCombinedCode + 177268
;

const JSC::ConstructAbility s_moduleLoaderRequestSatisfyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestSatisfyCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestSatisfyCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderRequestSatisfyCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderRequestSatisfyCodeLength = 990;
static const JSC::Intrinsic s_moduleLoaderRequestSatisfyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestSatisfyCode =
s_JSCCombinedCode + 178528
;

const JSC::ConstructAbility s_moduleLoaderRequestSatisfyUtilCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestSatisfyUtilCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderRequestSatisfyUtilCodeImplementationVisibility = JSC::ImplementationVisibility::PrivateRecursive;
const JSC::InlineAttribute s_moduleLoaderRequestSatisfyUtilCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderRequestSatisfyUtilCodeLength = 1723;
static const JSC::Intrinsic s_moduleLoaderRequestSatisfyUtilCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestSatisfyUtilCode =
s_JSCCombinedCode + 179518
;

const JSC::ConstructAbility s_promiseConstructorResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorResolveCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorResolveCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorResolveCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorResolveCodeLength = 162;
static const JSC::Intrinsic s_promiseConstructorResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorResolveCode =
s_JSCCombinedCode + 181241
;

const JSC::ConstructAbility s_promiseOperationsResolvePromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolvePromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolvePromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsResolvePromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsResolvePromiseCodeLength = 782;
static const JSC::Intrinsic s_promiseOperationsResolvePromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolvePromiseCode =
s_JSCCombinedCode + 181403
;

const JSC::ConstructAbility s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeLength = 389;
static const JSC::Intrinsic s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 182185
;

const JSC::ConstructAbility s_promiseOperationsResolveWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolveWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolveWithoutPromiseCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsResolveWithoutPromiseCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsResolveWithoutPromiseCodeLength = 867;
static const JSC::Intrinsic s_promiseOperationsResolveWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolveWithoutPromiseCode =
s_JSCCombinedCode + 182574
;

const JSC::ConstructAbility s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeLength = 532;
static const JSC::Intrinsic s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolveWithoutPromiseForAsyncAwaitCode =
s_JSCCombinedCode + 183441
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeReturnCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeReturnCodeLength = 1464;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeReturnCode =
s_JSCCombinedCode + 183973
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncGeneratorPrototypeReturnCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeReturnCodeLength = 118;
static const JSC::Intrinsic s_asyncGeneratorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeReturnCode =
s_JSCCombinedCode + 185437
;

const JSC::ConstructAbility s_generatorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeReturnCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_generatorPrototypeReturnCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_generatorPrototypeReturnCodeLength = 436;
static const JSC::Intrinsic s_generatorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeReturnCode =
s_JSCCombinedCode + 185555
;

const JSC::ConstructAbility s_regExpPrototypeSearchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeSearchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeSearchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpPrototypeSearchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeSearchCodeLength = 846;
static const JSC::Intrinsic s_regExpPrototypeSearchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeSearchCode =
s_JSCCombinedCode + 185991
;

const JSC::ConstructAbility s_stringPrototypeSearchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSearchCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSearchCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeSearchCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeSearchCodeLength = 498;
static const JSC::Intrinsic s_stringPrototypeSearchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSearchCode =
s_JSCCombinedCode + 186837
;

const JSC::ConstructAbility s_setIteratorPrototypeSetIteratorNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setIteratorPrototypeSetIteratorNextCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setIteratorPrototypeSetIteratorNextCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_setIteratorPrototypeSetIteratorNextCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setIteratorPrototypeSetIteratorNextCodeLength = 394;
static const JSC::Intrinsic s_setIteratorPrototypeSetIteratorNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setIteratorPrototypeSetIteratorNextCode =
s_JSCCombinedCode + 187335
;

const JSC::ConstructAbility s_moduleLoaderSetStateToMaxCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderSetStateToMaxCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_moduleLoaderSetStateToMaxCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_moduleLoaderSetStateToMaxCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_moduleLoaderSetStateToMaxCodeLength = 124;
static const JSC::Intrinsic s_moduleLoaderSetStateToMaxCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderSetStateToMaxCode =
s_JSCCombinedCode + 187729
;

const JSC::ConstructAbility s_stringPrototypeSmallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSmallCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSmallCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeSmallCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeSmallCodeLength = 109;
static const JSC::Intrinsic s_stringPrototypeSmallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSmallCode =
s_JSCCombinedCode + 187853
;

const JSC::ConstructAbility s_arrayPrototypeSomeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSomeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSomeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeSomeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSomeCodeLength = 532;
static const JSC::Intrinsic s_arrayPrototypeSomeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSomeCode =
s_JSCCombinedCode + 187962
;

const JSC::ConstructAbility s_typedArrayPrototypeSomeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeSomeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeSomeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeSomeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeSomeCodeLength = 386;
static const JSC::Intrinsic s_typedArrayPrototypeSomeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeSomeCode =
s_JSCCombinedCode + 188494
;

const JSC::ConstructAbility s_arrayPrototypeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeSortCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortCodeLength = 944;
static const JSC::Intrinsic s_arrayPrototypeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCode =
s_JSCCombinedCode + 188880
;

const JSC::ConstructAbility s_arrayPrototypeSortBucketSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortBucketSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortBucketSortCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeSortBucketSortCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortBucketSortCodeLength = 1056;
static const JSC::Intrinsic s_arrayPrototypeSortBucketSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortBucketSortCode =
s_JSCCombinedCode + 189824
;

const JSC::ConstructAbility s_arrayPrototypeSortCommitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCommitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortCommitCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeSortCommitCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortCommitCodeLength = 647;
static const JSC::Intrinsic s_arrayPrototypeSortCommitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCommitCode =
s_JSCCombinedCode + 190880
;

const JSC::ConstructAbility s_arrayPrototypeSortCompactCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCompactCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortCompactCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeSortCompactCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortCompactCodeLength = 577;
static const JSC::Intrinsic s_arrayPrototypeSortCompactCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCompactCode =
s_JSCCombinedCode + 191527
;

const JSC::ConstructAbility s_arrayPrototypeSortMergeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortMergeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortMergeCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeSortMergeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortMergeCodeLength = 850;
static const JSC::Intrinsic s_arrayPrototypeSortMergeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortMergeCode =
s_JSCCombinedCode + 192104
;

const JSC::ConstructAbility s_arrayPrototypeSortMergeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortMergeSortCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortMergeSortCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeSortMergeSortCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortMergeSortCodeLength = 476;
static const JSC::Intrinsic s_arrayPrototypeSortMergeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortMergeSortCode =
s_JSCCombinedCode + 192954
;

const JSC::ConstructAbility s_arrayPrototypeSortStringComparatorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortStringComparatorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeSortStringComparatorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_arrayPrototypeSortStringComparatorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeSortStringComparatorCodeLength = 185;
static const JSC::Intrinsic s_arrayPrototypeSortStringComparatorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortStringComparatorCode =
s_JSCCombinedCode + 193430
;

const JSC::ConstructAbility s_globalOperationsSpeciesConstructorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsSpeciesConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_globalOperationsSpeciesConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_globalOperationsSpeciesConstructorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_globalOperationsSpeciesConstructorCodeLength = 542;
static const JSC::Intrinsic s_globalOperationsSpeciesConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsSpeciesConstructorCode =
s_JSCCombinedCode + 193615
;

const JSC::ConstructAbility s_regExpPrototypeSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeSplitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeSplitCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpPrototypeSplitCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeSplitCodeLength = 3253;
static const JSC::Intrinsic s_regExpPrototypeSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeSplitCode =
s_JSCCombinedCode + 194157
;

const JSC::ConstructAbility s_stringPrototypeSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSplitCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSplitCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeSplitCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeSplitCodeLength = 449;
static const JSC::Intrinsic s_stringPrototypeSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSplitCode =
s_JSCCombinedCode + 197410
;

const JSC::ConstructAbility s_stringPrototypeStrikeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeStrikeCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeStrikeCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeStrikeCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeStrikeCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeStrikeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeStrikeCode =
s_JSCCombinedCode + 197859
;

const JSC::ConstructAbility s_stringPrototypeStringConcatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeStringConcatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeStringConcatSlowPathCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_stringPrototypeStringConcatSlowPathCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeStringConcatSlowPathCodeLength = 197;
static const JSC::Intrinsic s_stringPrototypeStringConcatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeStringConcatSlowPathCode =
s_JSCCombinedCode + 197970
;

const JSC::ConstructAbility s_stringPrototypeSubCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSubCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSubCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeSubCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeSubCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeSubCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSubCode =
s_JSCCombinedCode + 198167
;

const JSC::ConstructAbility s_stringPrototypeSupCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSupCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_stringPrototypeSupCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_stringPrototypeSupCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_stringPrototypeSupCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeSupCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSupCode =
s_JSCCombinedCode + 198272
;

const JSC::ConstructAbility s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeLength = 54;
static const JSC::Intrinsic s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCode =
s_JSCCombinedCode + 198377
;

const JSC::ConstructAbility s_functionPrototypeSymbolHasInstanceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeSymbolHasInstanceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_functionPrototypeSymbolHasInstanceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_functionPrototypeSymbolHasInstanceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_functionPrototypeSymbolHasInstanceCodeLength = 253;
static const JSC::Intrinsic s_functionPrototypeSymbolHasInstanceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeSymbolHasInstanceCode =
s_JSCCombinedCode + 198431
;

const JSC::ConstructAbility s_iteratorPrototypeSymbolIteratorGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorPrototypeSymbolIteratorGetterCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorPrototypeSymbolIteratorGetterCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_iteratorPrototypeSymbolIteratorGetterCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_iteratorPrototypeSymbolIteratorGetterCodeLength = 54;
static const JSC::Intrinsic s_iteratorPrototypeSymbolIteratorGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorPrototypeSymbolIteratorGetterCode =
s_JSCCombinedCode + 198684
;

const JSC::ConstructAbility s_setPrototypeSymmetricDifferenceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeSymmetricDifferenceCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeSymmetricDifferenceCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeSymmetricDifferenceCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeSymmetricDifferenceCodeLength = 806;
static const JSC::Intrinsic s_setPrototypeSymmetricDifferenceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeSymmetricDifferenceCode =
s_JSCCombinedCode + 198738
;

const JSC::ConstructAbility s_regExpPrototypeTestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeTestCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_regExpPrototypeTestCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_regExpPrototypeTestCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_regExpPrototypeTestCodeLength = 560;
static const JSC::Intrinsic s_regExpPrototypeTestCodeIntrinsic = JSC::RegExpTestIntrinsic;
const char* const s_regExpPrototypeTestCode =
s_JSCCombinedCode + 199544
;

const JSC::ConstructAbility s_promisePrototypeThenCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeThenCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promisePrototypeThenCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promisePrototypeThenCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promisePrototypeThenCodeLength = 612;
static const JSC::Intrinsic s_promisePrototypeThenCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeThenCode =
s_JSCCombinedCode + 200104
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncFromSyncIteratorPrototypeThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncFromSyncIteratorPrototypeThrowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncFromSyncIteratorPrototypeThrowCodeLength = 1469;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeThrowCode =
s_JSCCombinedCode + 200716
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_asyncGeneratorPrototypeThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_asyncGeneratorPrototypeThrowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_asyncGeneratorPrototypeThrowCodeLength = 129;
static const JSC::Intrinsic s_asyncGeneratorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeThrowCode =
s_JSCCombinedCode + 202185
;

const JSC::ConstructAbility s_generatorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_generatorPrototypeThrowCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_generatorPrototypeThrowCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_generatorPrototypeThrowCodeLength = 518;
static const JSC::Intrinsic s_generatorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeThrowCode =
s_JSCCombinedCode + 202314
;

const JSC::ConstructAbility s_typedArrayPrototypeToLocaleStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeToLocaleStringCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeToLocaleStringCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_typedArrayPrototypeToLocaleStringCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeToLocaleStringCodeLength = 411;
static const JSC::Intrinsic s_typedArrayPrototypeToLocaleStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeToLocaleStringCode =
s_JSCCombinedCode + 202832
;

const JSC::ConstructAbility s_arrayPrototypeToReversedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeToReversedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeToReversedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeToReversedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeToReversedCodeLength = 422;
static const JSC::Intrinsic s_arrayPrototypeToReversedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeToReversedCode =
s_JSCCombinedCode + 203243
;

const JSC::ConstructAbility s_arrayPrototypeToSortedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeToSortedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeToSortedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeToSortedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeToSortedCodeLength = 611;
static const JSC::Intrinsic s_arrayPrototypeToSortedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeToSortedCode =
s_JSCCombinedCode + 203665
;

const JSC::ConstructAbility s_arrayPrototypeToSplicedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeToSplicedCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeToSplicedCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeToSplicedCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeToSplicedCodeLength = 1642;
static const JSC::Intrinsic s_arrayPrototypeToSplicedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeToSplicedCode =
s_JSCCombinedCode + 204276
;

const JSC::ConstructAbility s_promiseOperationsTriggerPromiseReactionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsTriggerPromiseReactionsCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseOperationsTriggerPromiseReactionsCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_promiseOperationsTriggerPromiseReactionsCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseOperationsTriggerPromiseReactionsCodeLength = 725;
static const JSC::Intrinsic s_promiseOperationsTriggerPromiseReactionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsTriggerPromiseReactionsCode =
s_JSCCombinedCode + 205918
;

const JSC::ConstructAbility s_typedArrayPrototypeTypedArraySpeciesConstructorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeTypedArraySpeciesConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_typedArrayPrototypeTypedArraySpeciesConstructorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_typedArrayPrototypeTypedArraySpeciesConstructorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_typedArrayPrototypeTypedArraySpeciesConstructorCodeLength = 478;
static const JSC::Intrinsic s_typedArrayPrototypeTypedArraySpeciesConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeTypedArraySpeciesConstructorCode =
s_JSCCombinedCode + 206643
;

const JSC::ConstructAbility s_setPrototypeUnionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeUnionCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_setPrototypeUnionCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_setPrototypeUnionCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_setPrototypeUnionCodeLength = 690;
static const JSC::Intrinsic s_setPrototypeUnionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeUnionCode =
s_JSCCombinedCode + 207121
;

const JSC::ConstructAbility s_arrayPrototypeWithCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeWithCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_arrayPrototypeWithCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_arrayPrototypeWithCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_arrayPrototypeWithCodeLength = 797;
static const JSC::Intrinsic s_arrayPrototypeWithCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeWithCode =
s_JSCCombinedCode + 207811
;

const JSC::ConstructAbility s_promiseConstructorWithResolversCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorWithResolversCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_promiseConstructorWithResolversCodeImplementationVisibility = JSC::ImplementationVisibility::Public;
const JSC::InlineAttribute s_promiseConstructorWithResolversCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_promiseConstructorWithResolversCodeLength = 77;
static const JSC::Intrinsic s_promiseConstructorWithResolversCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorWithResolversCode =
s_JSCCombinedCode + 208608
;

const JSC::ConstructAbility s_shadowRealmPrototypeWrapRemoteValueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_shadowRealmPrototypeWrapRemoteValueCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_shadowRealmPrototypeWrapRemoteValueCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_shadowRealmPrototypeWrapRemoteValueCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_shadowRealmPrototypeWrapRemoteValueCodeLength = 321;
static const JSC::Intrinsic s_shadowRealmPrototypeWrapRemoteValueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_shadowRealmPrototypeWrapRemoteValueCode =
s_JSCCombinedCode + 208685
;

const JSC::ConstructAbility s_iteratorHelpersWrappedIteratorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersWrappedIteratorCodeConstructorKind = JSC::ConstructorKind::None;
const JSC::ImplementationVisibility s_iteratorHelpersWrappedIteratorCodeImplementationVisibility = JSC::ImplementationVisibility::Private;
const JSC::InlineAttribute s_iteratorHelpersWrappedIteratorCodeInlineAttribute = JSC::InlineAttribute::None;
const int s_iteratorHelpersWrappedIteratorCodeLength = 144;
static const JSC::Intrinsic s_iteratorHelpersWrappedIteratorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersWrappedIteratorCode =
s_JSCCombinedCode + 209006
;


#define DEFINE_BUILTIN_GENERATOR(codeName, functionName, overriddenName, argumentCount) \
JSC::FunctionExecutable* codeName##Generator(JSC::VM& vm) \
{\
    return vm.builtinExecutables()->codeName##Executable()->link(vm, nullptr, vm.builtinExecutables()->codeName##Source(), std::nullopt, s_##codeName##Intrinsic); }
JSC_FOREACH_BUILTIN_CODE(DEFINE_BUILTIN_GENERATOR)
#undef DEFINE_BUILTIN_GENERATOR


} // namespace JSC
